# Loki: Freely programmable source-to-source translation

[![license](https://img.shields.io/github/license/ecmwf-ifs/loki)](https://www.apache.org/licenses/LICENSE-2.0.html)
[![code-checks](https://github.com/ecmwf-ifs/loki/actions/workflows/code_checks.yml/badge.svg)](https://github.com/ecmwf-ifs/loki/actions/workflows/code_checks.yml)
[![tests](https://github.com/ecmwf-ifs/loki/actions/workflows/tests.yml/badge.svg)](https://github.com/ecmwf-ifs/loki/actions/workflows/tests.yml)
[![regression-tests](https://github.com/ecmwf-ifs/loki/actions/workflows/regression_tests.yml/badge.svg)](https://github.com/ecmwf-ifs/loki/actions/workflows/regression_tests.yml)
[![codecov](https://codecov.io/gh/ecmwf-ifs/loki/branch/main/graph/badge.svg?token=9ZDS95SFWI)](https://codecov.io/gh/ecmwf-ifs/loki)

**Loki is an experimental tool** to explore the possible use of
source-to-source translation for ECMWF's Integrated Forecasting System (IFS) and
associated Fortran software packages.

Loki is based on compiler technology (visitor patterns and ASTs) and aims to
provide an abstract, language-agnostic representation of a kernel, as well as a
programmable (pythonic) interface that allows developers to experiment with
different kernel implementations and optimizations.  The aim is to allow changes
to programming models and coding styles to be encoded and automated instead of
hand-applying them, enabling advanced experimentation with large kernels as well
as bulk processing of large numbers of source files to evaluate different kernel
implementations and programming models.

*This package is made available to support research collaborations and is not
officially supported by ECMWF.*

## Contact

Michael Lange (michael.lange@ecmwf.int),
Balthasar Reuter (balthasar.reuter@ecmwf.int)

## License

Loki is distributed under the [Apache License 2.0](LICENSE). In applying this
licence, ECMWF does not waive the privileges and immunities granted to it by
virtue of its status as an intergovernmental organisation nor does it submit to
any jurisdiction.

## Installation

See [INSTALL.md](INSTALL.md).

## Documentation

Loki has a comprehensive [documentation](https://sites.ecmwf.int/docs/loki) that
describes the API and how to use it to write custom transformations.  There are
also a number of Jupyter notebooks available in the
[example directory](https://github.com/ecmwf-ifs/loki/blob/main/example) that help
getting up to speed with the core functionality of the package.

## Contributing

Contributions to Loki are welcome. In order to do so, please open an issue where
a feature request or bug can be discussed. Then create a pull request with your
contribution and sign the
[contributors license agreement (CLA)](http://claassistant.ecmwf.int/ecmwf-ifs/loki).

# Loki: Freely programmable source-to-source translation

[![license](https://img.shields.io/github/license/ecmwf-ifs/loki)](https://www.apache.org/licenses/LICENSE-2.0.html)
[![code-checks](https://github.com/ecmwf-ifs/loki/actions/workflows/code_checks.yml/badge.svg)](https://github.com/ecmwf-ifs/loki/actions/workflows/code_checks.yml)
[![tests](https://github.com/ecmwf-ifs/loki/actions/workflows/tests.yml/badge.svg)](https://github.com/ecmwf-ifs/loki/actions/workflows/tests.yml)
[![regression-tests](https://github.com/ecmwf-ifs/loki/actions/workflows/regression_tests.yml/badge.svg)](https://github.com/ecmwf-ifs/loki/actions/workflows/regression_tests.yml)
[![codecov](https://codecov.io/gh/ecmwf-ifs/loki/branch/main/graph/badge.svg?token=9ZDS95SFWI)](https://codecov.io/gh/ecmwf-ifs/loki)

**Loki is an experimental tool** to explore the possible use of
source-to-source translation for ECMWF's Integrated Forecasting System (IFS) and
associated Fortran software packages.

Loki is based on compiler technology (visitor patterns and ASTs) and aims to
provide an abstract, language-agnostic representation of a kernel, as well as a
programmable (pythonic) interface that allows developers to experiment with
different kernel implementations and optimizations.  The aim is to allow changes
to programming models and coding styles to be encoded and automated instead of
hand-applying them, enabling advanced experimentation with large kernels as well
as bulk processing of large numbers of source files to evaluate different kernel
implementations and programming models.

*This package is made available to support research collaborations and is not
officially supported by ECMWF.*

## Contact

Michael Lange (michael.lange@ecmwf.int),
Balthasar Reuter (balthasar.reuter@ecmwf.int)

## License

Loki is distributed under the [Apache License 2.0](LICENSE). In applying this
licence, ECMWF does not waive the privileges and immunities granted to it by
virtue of its status as an intergovernmental organisation nor does it submit to
any jurisdiction.

## Installation

See [INSTALL.md](INSTALL.md).

## Documentation

Loki has a comprehensive [documentation](https://sites.ecmwf.int/docs/loki) that
describes the API and how to use it to write custom transformations.  There are
also a number of Jupyter notebooks available in the
[example directory](https://github.com/ecmwf-ifs/loki/blob/main/example) that help
getting up to speed with the core functionality of the package.

## Contributing

Contributions to Loki are welcome. In order to do so, please open an issue where
a feature request or bug can be discussed. Then create a pull request with your
contribution and sign the
[contributors license agreement (CLA)](https://bol-claassistant.ecmwf.int/ecmwf-ifs/loki).

# cmake-jdk-ant

Contact: Balthasar Reuter (balthasar.reuter@ecmwf.int)

A CMake project to bootstrap OpenJDK and Ant during the configuration phase.

Variables influencing the behaviour of this CMake configuration:

* `MINIMUM_JAVA_VERSION`: The minimum JDK and JRE version that should be available. If no Java is found or a version too old, OpenJDK will be bootstrapped. Default: `11`
* `MINIMUM_ANT_VERSION`: The minimum Ant version that should be available. If no Ant is found or a version too old, Ant will be bootstrapped. Default: `1.10`
* `FORCE_OPEN_JDK_INSTALL`: Force bootstrapping of OpenJDK, regardless of any available version. Default: `OFF`
* `FORCE_ANT_INSTALL`: Force bootstrapping of Ant, regardless of any available version. Default: `OFF`
* `OPEN_JDK_INSTALL_VERSION`: The OpenJDK version to install. Default: `11.0.2`
* `ANT_INSTALL_VERSION`: The Ant version to install. Default: `1.10.12`
* `OPEN_JDK_MIRROR`: Allows to set an alternative mirror for OpenJDK download.
* `ANT_MIRROR`: Allows to set an alternative mirror for Ant download.

The purpose of this is to provide a way of on-the-fly installation of Java/Ant toolchain dependencies on systems where no usable setup is available.

## Example:

In a project that requires Java and Ant, add `cmake-jdk-ant` as a subdirectory:

```cmake
...
add_subdirectory( cmake-jdk-ant )
...
```

Subsequently, any calls to `find_package( Java )` will yield the bootstrapped toolchain.

Using the notebooks
===================

The notebooks contain many `import`  statements for loading various Loki modules. In order to ensure the interpreter can locate the relevant modules, the jupyter notebook server should be launched from a terminal where the `loki-env` virtual environment has been activated:

```bash
$ source <path-to-loki>/loki-activate
(loki_env) $ jupyter notebook
```

The interpreter used by the notebook server can be checked using the following command:

```bash
(loki_env) $ jupyter kernelspec list
Available kernels:
  python3    <path-to-loki>/loki_env/share/jupyter/kernels/python3
```

module transformation_module_hoist
    USE subroutines_mod, only: kernel1, kernel2, device1, device2
    implicit none
    integer, parameter :: len = 3
contains

    subroutine driver(a, b, c)
        integer, intent(in) :: a
        integer, intent(inout) :: b(a)
        integer, intent(inout) :: c(a, len)
        real :: x, y
        call kernel1(a, b, c)
        call kernel2(a, b)
        call kernel1(a, b, c)
    end subroutine driver

    subroutine another_driver(a, b, c)
        integer, intent(in) :: a
        integer, intent(inout) :: b(a)
        integer, intent(inout) :: c(a, len)
        real :: x, y
        call kernel1(a, b, c)
    end subroutine another_driver

end module transformation_module_hoist

subroutine routine_pp_macros()
#define CONSTANT 123
#define FLAG
  implicit none
  integer :: y, z
#define SOME_MACRO(x) x + 1
  y = 1
#define SOME_OTHER_MACRO (x - 1)
#
#warning 'ABC'
#ifdef FLAG
  z = 3
#endif
end subroutine routine_pp_macros

! Test file lifted from Fcm interface generation test suite
! https://github.com/metomi/fcm/blob/2-3/t/Fcm/Build/Fortran-extract-interface-source.f90

! A simple function
logical function func_simple()
func_simple = .true.
end function func_simple

! A simple function, but with less friendly end
logical function func_simple_1()
func_simple_1 = .true.
end function

! A simple function, but with even less friendly end
logical function func_simple_2()
func_simple_2 = .true.
end function

! A pure simple function
pure logical function func_simple_pure()
func_simple_pure = .true.
end function func_simple_pure

! A pure recursive function
recursive pure integer function func_simple_recursive_pure(i) result(result)
integer, intent(in) :: i
if (i <= 0) then
    result = i
else
    result = i + func_simple_recursive_pure(i - 1)
end if
end function func_simple_recursive_pure

! An elemental simple function
elemental logical function func_simple_elemental()
func_simple_elemental = .true.
end function func_simple_elemental

! A module with nonsense
module bar
type food
integer :: cooking_method
end type food
type organic
integer :: growing_method
end type organic
integer, parameter :: i_am_dim = 10
end module bar

! A module with more nonsense
module foo
use bar, only: FOOD
integer :: foo_int
contains
subroutine foo_sub(egg)
integer, parameter :: egg_dim = 10
type(Food), intent(in) :: egg
write(*, *) egg
end subroutine foo_sub
elemental function foo_func() result(f)
integer :: f
f = 0
end function
end module foo

! An function with arguments and module imports
integer(selected_int_kind(0)) function func_with_use_and_args(egg, ham)
use foo
! Deliberate trailing spaces in next line
use bar, only : organic,     i_am_dim
implicit none
integer, intent(in) :: egg(i_am_dim)
integer, intent(in) :: ham(i_am_dim, 2)
real bacon
! Deliberate trailing spaces in next line
type(   organic   ) :: tomato
func_with_use_and_args = egg(1) + ham(1, 1)
end function func_with_use_and_args

! A function with some parameters
character(20) function func_with_parameters(egg, ham)
implicit none
character*(*), parameter :: x_param = '01234567890'
character(*), parameter :: & ! throw in some comments
    y_param                &
    = '!&!&!&!&!&!'          ! how to make life interesting
integer, parameter :: z = 20
character(len(x_param)), intent(in) :: egg
character(len(y_param)), intent(in) :: ham
func_with_parameters = egg // ham
end function func_with_parameters

! A function with some parameters, with a result
function func_with_parameters_1(egg, ham) result(r)
implicit none
integer, parameter :: x_param = 10
integer z_param
parameter(z_param = 2)
real, intent(in), dimension(x_param) :: egg
integer, intent(in) :: ham
logical :: r(z_param)
r(1) = int(egg(1)) + ham > 0
r(2) = .false.
end function func_with_parameters_1

! A function with a contains
character(10) function func_with_contains(mushroom, tomoato)
character(5) mushroom
character(5) tomoato
func_with_contains = func_with_contains_1()
contains
character(10) function func_with_contains_1()
func_with_contains_1 = mushroom // tomoato
end function func_with_contains_1
end function func_with_contains

! A function with its result declared after a local in the same statement
Function func_mix_local_and_result(egg, ham, bacon) Result(Breakfast)
Integer, Intent(in) :: egg, ham
Real, Intent(in) :: bacon
Real :: tomato, breakfast
Breakfast = real(egg) + real(ham) + bacon
End Function func_mix_local_and_result

! A simple subroutine
subroutine sub_simple()
end subroutine sub_simple

! A simple subroutine, with not so friendly end
subroutine sub_simple_1()
end subroutine

! A simple subroutine, with even less friendly end
subroutine sub_simple_2()
end subroutine

! A simple subroutine, with funny continuation
subroutine sub_simple_3()
end sub&
&routine&
& sub_simple_3

! A subroutine with a few contains
subroutine sub_with_contains(foo) ! " &
! Deliberate trailing spaces in next line
use Bar, only: i_am_dim
character*(len('!"&''&"!')) & ! what a mess!
    foo
call sub_with_contains_first()
call sub_with_contains_second()
call sub_with_contains_third()
print*, foo
contains
subroutine sub_with_contains_first()
interface
integer function x()
end function x
end interface
end subroutine sub_with_contains_first
subroutine sub_with_contains_second()
end subroutine
subroutine sub_with_contains_third()
end subroutine
end subroutine sub_with_contains

! A subroutine with a renamed module import
subroutine sub_with_renamed_import(i_am_dim)
use bar, only: i_am_not_dim => i_am_dim
integer, parameter :: d = 2
complex :: i_am_dim(d)
print*, i_am_dim
end subroutine sub_with_renamed_import

! A subroutine with an external argument
subroutine sub_with_external(proc)
external proc
call proc()
end subroutine sub_with_external

! A subroutine with a variable named "end"
subroutine sub_with_end()
integer :: end
end = 0
end subroutine sub_with_end

MODULE driver_mod
    USE KERNEL_MOD, ONLY: KERNEL
    IMPLICIT NONE
CONTAINS
    SUBROUTINE driver(nlon, nz, nb, tot, q, t, z)
        INTEGER, INTENT(IN)   :: nlon, nz, nb  ! Size of the horizontal and vertical
        INTEGER, INTENT(IN)   :: tot
        REAL, INTENT(INOUT)   :: t(nlon,nz,nb)
        REAL, INTENT(INOUT)   :: q(nlon,nz,nb)
        REAL, INTENT(INOUT)   :: z(nlon,nz+1,nb)
        INTEGER :: b, start, iend, ibl, icend

        start = 1
        iend = tot
        do b=1,iend,nlon
          ibl = (b-1)/nlon+1
          icend = MIN(nlon,tot-b+1)
          call kernel(start, icend, nlon, nz, q(:,:,b), t(:,:,b), z(:,:,b))
        end do

       do b=1,iend,nlon
          ibl = (b-1)/nlon+1
          icend = MIN(nlon,tot-b+1)
          call kernel(start, icend, nlon, nz, q(:,:,b), t(:,:,b), z(:,:,b))
          call kernel(start, icend, nlon, nz, q(:,:,b), t(:,:,b), z(:,:,b))
       end do

    END SUBROUTINE driver
END MODULE driver_mod

subroutine routine_a
  integer a, i
  a = 1
  i = a + 1

  call routine_b(a, i)
end subroutine routine_a

module some_module
contains
  subroutine module_routine
    integer m
    m = 2

    call routine_b(m, 6)
  end subroutine module_routine

  function module_function(n)
    integer n
    n = 3
  end function module_function
end module some_module

subroutine routine_b(i,j)
  integer, intent(in) :: i, j
  integer b
  b = 4

  call contained_c(i)

  call routine_a()
contains

  subroutine contained_c(i)
    integer, intent(in) :: i
    integer c
    c = 5
  end subroutine contained_c

  subroutine contained_d(i)
    integer, intent(in) :: i
    integer c
    c = 8
  end subroutine contained_d
end subroutine routine_b

function function_d(d)
integer d
d = 6
end function function_d

module typebound_item
    use typebound_header
    implicit none

    type some_type
    contains
        procedure, nopass :: routine => module_routine
        procedure :: some_routine
        procedure, pass :: other_routine
        procedure :: routine1, &
            & routine2 => routine
        ! procedure :: routine1
        ! procedure :: routine2 => routine
    end type some_type
contains
    subroutine module_routine
        integer m
        m = 2
    end subroutine module_routine

    subroutine some_routine(self)
        class(some_type) :: self

        call self%routine
    end subroutine some_routine

    subroutine other_routine(self, m)
        class(some_type), intent(inout) :: self
        integer, intent(in) :: m
        integer :: j

        if (m < 0) call abor1('Error with unbalanced parenthesis)')

        j = m
        call self%routine1
        call self%routine2
    end subroutine other_routine

    subroutine routine(self)
        class(some_type) :: self
        call self%some_routine
    end subroutine routine

    subroutine routine1(self)
        class(some_type) :: self
        call module_routine
    end subroutine routine1
end module typebound_item

subroutine driver
    use typebound_item
    use typebound_header
    use typebound_other, only: other => other_type
    implicit none

    type(some_type), allocatable :: obj(:), obj2(:,:)
    type(header_type) :: header
    type(other) :: other_obj, derived(2)
    real :: x
    integer :: i

    allocate(obj(1))
    allocate(obj2(1,1))
    call obj(1)%other_routine(5)
    call obj2(1,1)%some_routine
    call header%member_routine(1)
    call header%routine(x)
    call header%routine(i)
    call other_obj%member(2, 2)
    call derived(1)% var( 2 ) % member_routine(2)
end subroutine driver

module some_module
implicit none

  integer, parameter :: some_var=1

  interface add_args
    procedure add_two_args
    procedure add_three_args
  end interface add_args

  type some_type
    real :: c = 1.
    contains
      procedure :: do_something => add_const
  end type

contains

  function return_one() result(one)
     real :: one
     one = 1.
  end function return_one

  function add_two_args(i,j) result(res)
     integer, intent(in) :: i,j
     real :: res
     res = dble(i+j)
  end function add_two_args

  function add_three_args(i,j,k) result(res)
     integer, intent(in) :: i,j,k
     real :: res
     res = dble(i+j+k)
  end function add_three_args

  subroutine add_const(self, a)
     class(some_type), intent(in) :: self
     real, intent(inout) :: a

     a = a + self%c
  end subroutine add_const

end module some_module

module kernel

    use types, only: parent_type

    implicit none

    public kernel_routine

    contains

    subroutine kernel_routine(size, pt)
        integer, intent(in) :: size
        type(parent_type), intent(inout) :: pt

        integer :: i

        do i=1,size
            pt%type_member%x(i) = pt%member*pt%type_member%x(i)
        end do

    end subroutine kernel_routine

end module kernel

MODULE KERNEL_MOD
    IMPLICIT NONE
    CONTAINS
    SUBROUTINE kernel(start, iend, nlon, nz, q, t, z)
        INTEGER, INTENT(IN) :: start, iend, nlon, nz
        REAL, INTENT(INOUT) :: t(nlon,nz)
        REAL, INTENT(INOUT) :: q(nlon,nz)
        REAL, INTENT(INOUT) :: z(nlon,nz)
        REAL    :: local_z(nlon, nz)
        INTEGER :: jl, jk
        REAL :: c

        c = SOME_FUNC(A=5.345)
        DO jk = 2, nz
          DO jl = start, iend
            call ELEMENTAL_DEVICE(z(jl, jk))
          END DO
        END DO

        call DEVICE(nlon, nz, 2, start, iend, z)

        c = 5.345
        DO jk = 2, nz
          DO jl = start, iend
            t(jl, jk) = c * jk
            q(jl, jk) = q(jl, jk-1) + t(jl, jk) * c
          END DO
        END DO

        DO jk = 2, nz
          DO jl = start, iend
            local_z(jl, jk) = 0.0
            z(jl, jk) = local_z(jl, jk)
          END DO
        END DO

    END SUBROUTINE kernel

    PURE ELEMENTAL SUBROUTINE ELEMENTAL_DEVICE(x) ! elemental
      REAL, INTENT(INOUT) :: x
      x = 0.0
    END SUBROUTINE ELEMENTAL_DEVICE

    SUBROUTINE DEVICE(nlon, nz, jk_start, start, iend, x)
        INTEGER, INTENT(IN) :: jk_start, start, iend, nlon, nz
        REAL, INTENT(INOUT) :: x(nlon, nz)
        REAL    :: local_x(nlon, nz)
        INTEGER :: jk, jl
        DO jk = jk_start, nz
            DO jl = start, iend
                local_x(jl, jk) = 0.0
                x(jl, jk) = local_x(jl, jk)
            END DO
        END DO
    END SUBROUTINE DEVICE

    FUNCTION SOME_FUNC(A)
        REAL, INTENT(IN) :: A
        REAL :: SOME_FUNC
        !$loki routine seq
        SOME_FUNC = A
    END FUNCTION SOME_FUNC

END MODULE KERNEL_MOD

module header
  ! header module to provide external typedefs
  integer, parameter :: jprb = selected_real_kind(13,300)

  type derived_type
    real(kind=jprb) :: scalar, vector(3), matrix(3, 3)
    real(kind=jprb) :: red_herring
  end type derived_type

end module header

MODULE KERNEL_A_MOD
USE KERNEL_A1_MOD, ONLY: KERNEL_A1
IMPLICIT NONE
CONTAINS
  SUBROUTINE kernel_a(a, b, c)
    USE VAR_MODULE_MOD, only: n
    REAL, INTENT(INOUT)   :: a(:)
    REAL, INTENT(INOUT)   :: b(:,:)
    REAL, INTENT(INOUT)   :: c(:,:)

    CALL kernel_a1(b, c)
  END SUBROUTINE kernel_a

END MODULE KERNEL_A_MOD

MODULE DRIVER_MOD
USE KERNEL_A_MOD, ONLY: KERNEL_A
USE KERNEL_B_MOD, ONLY: KERNEL_B
IMPLICIT NONE
CONTAINS
  SUBROUTINE driver(nlon, nlev, a, b, c)
    INTEGER, INTENT(IN)   :: nlon, nlev  ! Dimension sizes
    INTEGER, PARAMETER    :: n = 5
    REAL, INTENT(INOUT)   :: a(nlon)
    REAL, INTENT(INOUT)   :: b(nlon,nlev)
    REAL, INTENT(INOUT)   :: c(nlon,n)

    call kernel_a(a, b, c)

    call kernel_b(b, c)
  END SUBROUTINE driver

END MODULE DRIVER_MOD

module proj_c_util_mod
  integer, parameter :: jprb = 4

contains

  subroutine routine_one(matrix)
    real(kind=jprb), intent(inout) :: matrix(:,:)
    integer :: i

    do i = 1, size(matrix, dim=1)
      call routine_two(matrix(i,:))
    end do
  end subroutine routine_one

  subroutine routine_two(vector)
    real(kind=jprb), intent(inout) :: vector(:)

    vector(:) = vector(:) + 2.0
  end subroutine routine_two

end module proj_c_util_mod

module driverC_mod
  use header_mod, only: jprb, header_type
  use kernelC_mod, only: kernelC

  implicit none

contains

  subroutine driverC()
    type(header_type) :: mystruct

    call kernelC(mystruct%vector, mystruct%matrix)

  end subroutine driverC

end module driverC_mod

subroutine sourcefile_external_preprocessing(a, b)
  real(kind=8), intent(inout) :: a, b
#include "some_header.h"
#ifdef FLAG_SMALL
#define CONSTANT 6
#else
#define CONSTANT 123
#endif

#define ADD_ONE(x) x + 1

  a = ADD_ONE(5)
  b = CONSTANT
end subroutine sourcefile_external_preprocessing

module parametrise
    implicit none
contains

    subroutine stop_execution(msg)
        character(200), INTENT(IN) :: msg
        PRINT *, msg
        stop 1
    end subroutine stop_execution

    subroutine driver(a, b, c, d)
        integer, intent(inout) :: a, b, d(b)
        integer, intent(inout) :: c(a, b)
        real :: x, y
        call kernel1(a, b, c)
        call kernel2(a, b, d)
        call kernel1(a, b, c)
    end subroutine driver

    subroutine another_driver(a, b, c)
        integer, intent(in) :: a
        integer, intent(in) :: b
        integer, intent(inout) :: c(a, b)
        real :: x(a)
        call kernel1(a, b, c)
    end subroutine another_driver

    subroutine kernel1(a, b, c)
        integer, intent(in) :: a
        integer, intent(in) :: b
        integer, intent(inout) :: c(a, b)
        integer :: local_a
        real :: x(a)
        integer :: y(a, b)
        real :: k1_tmp(a, b)
        y = 11
        c = y
    end subroutine kernel1

    subroutine kernel2(a_new, b, d)
        integer, intent(in) :: a_new
        integer, intent(in) :: b
        integer, intent(inout) :: d(b)
        real :: x(a_new)
        real :: y, z
        real :: k2_tmp(a_new, a_new)
        call device1(a_new, b, d, x, k2_tmp)
    end subroutine kernel2

    subroutine device1(a, b, d, x, y)
        integer, intent(in) :: a
        integer, intent(in) :: b
        integer, intent(inout) :: d(b)
        real, intent(inout) :: x(a)
        real, intent(inout) :: y(a, a)
        real :: z
        integer :: d1_tmp
        call device2(a, b, d, x)
        call device2(a, b, d, x)
    end subroutine device1

    subroutine device2(a, b, d, x)
        integer, intent(in) :: a
        integer, intent(in) :: b
        integer, intent(inout) :: d(b)
        real, intent(inout) :: x(a)
        integer z(b)
        integer :: d2_tmp(b)
        z = 42
        d = z
    end subroutine device2

end module parametrise

subroutine comp2 (arg, val)
    use t_mod, only: t
    use header_mod, only: k
    use a_mod, only: a
    use b_mod, only: b
    implicit none
    type(t), intent(inout) :: arg
    real(kind=k), intent(inout) :: val(:)

    call a(t%yay%indirection)
    call b(val)
    call arg%yay%proc()
end subroutine comp2

module kernelC_mod
  use header_mod, only: jprb
  use compute_l1_mod, only: compute_l1
  use proj_c_util_mod, only: routine_one

  implicit none

contains

  subroutine kernelC(vector, matrix)
    real(kind=jprb), intent(inout) :: vector(:)
    real(kind=jprb), intent(inout) :: matrix(:)

    call compute_l1(vector)

    call routine_one(matrix)
  end subroutine kernelC

end module kernelC_mod

subroutine another_l1(matrix)
  use header_mod, only: jprb

  implicit none

  real(kind=jprb), intent(inout) :: matrix(:,:)

#include "another_l2.intfb.h"

  call another_l2(matrix)

end subroutine another_l1

module math_operations
  implicit none

  public :: add, subtract, multiply

contains

  ! Subroutine to add two numbers
  subroutine add(x, y, result)
    real, intent(in) :: x, y
    real, intent(out) :: result
    result = x + y
  end subroutine add

  ! Subroutine to subtract two numbers
  subroutine subtract(x, y, result)
    real, intent(in) :: x, y
    real, intent(out) :: result
    result = x - y
  end subroutine subtract

  ! Subroutine to multiply two numbers
  subroutine multiply(x, y, result)
    real, intent(in) :: x, y
    real, intent(out) :: result
    result = x * y
  end subroutine multiply

end module math_operations

subroutine single_loop(arr, n)
  implicit none
  integer, intent(inout) :: arr(:)
  integer, intent(in) :: n
  integer :: i

  do i = 1, n
    arr(i) = arr(i) * 2
  end do
end subroutine single_loop

subroutine single_loop_split_access(arr, n)
  implicit none
  integer, intent(inout) :: arr(:)
  integer, intent(in) :: n
  integer :: i, nhalf
  nhalf = n/2
  do i = 1, nhalf
    arr(2*i) = arr(2*i) * 2
    arr(2*i + 1) = arr(2*i + 1) * 2
  end do
end subroutine single_loop_split_access

subroutine single_loop_arithmetic_operations_for_access(arr, n)
  implicit none
  integer, intent(inout) :: arr(:)
  integer, intent(in) :: n
  integer :: i

  do i = 1, n
    arr(i*i) = arr(i + i) * 2
  end do
end subroutine single_loop_arithmetic_operations_for_access

subroutine nested_loop_single_dimensions_access(arr, n)
  implicit none
  integer, intent(inout) :: arr(:)
  integer, intent(in) :: n
  integer :: i, j, nhalf

  nhalf = n/2
  do i = 1, nhalf
    do j = 1, nhalf
          arr(i + j) = arr(i + j) * 2
    end do
  end do
end subroutine nested_loop_single_dimensions_access



subroutine nested_loop_partially_used(arr, n)
  implicit none
  integer, intent(inout) :: arr(:)
  integer, intent(in) :: n
  integer :: i, j, nfourth

  nfourth = n / 4
  do i = 1, nfourth
    do j = 1, nfourth
          arr(i + j) = arr(i + j) * 2
    end do
  end do
end subroutine nested_loop_partially_used


subroutine partially_used_array(arr, n)
  implicit none
  integer, intent(out) :: arr(:)
  integer, intent(in) :: n
  integer :: i = 1 , j = 3, nhalf

  nhalf = n/2
  arr(1) = 1
  do i = 2, nhalf
    arr(i) = arr(i - 1)
  end do

  j = arr(j)
end subroutine partially_used_array

module wrapper
  implicit none
  integer, parameter :: jprb = selected_real_kind(13,300)

contains

  subroutine mult_add_external(a, b, c, sum)
    implicit none

    interface
       subroutine mult_add_fc(a, b, c, sum) &
            & bind(c, name='mult_add_c')
         use iso_c_binding, only: c_double
         implicit none

         ! Pass values in by value, out by reference
         real(kind=c_double), value :: a, b, c
         real(kind=c_double) :: sum
       end subroutine mult_add_fc
    end interface

    real(kind=jprb), intent(in) :: a, b, c
    real(kind=jprb), intent(out) :: sum

    call mult_add_fc(a, b, c, sum)
  end subroutine mult_add_external

end module wrapper

module driverE_mod
  use header_mod, only: jprb, header_type
  use kernelE_mod, only: kernelE, kernelET

  implicit none

contains

  ! Two driver routines, but we process only one!

  subroutine driverE_single()
    type(header_type) :: mystruct

    call kernelE(mystruct%vector, mystruct%matrix)

  end subroutine driverE_single


  subroutine driverE_multiple()
    type(header_type) :: mystruct

    call kernelE(mystruct%vector, mystruct%matrix)

    call kernelET(mystruct%vector, mystruct%matrix)
  end subroutine driverE_multiple

end module driverE_mod

module base

  implicit none

  save

  integer, parameter :: jprb = selected_real_kind(13,300)

  real(kind=jprb) :: a, b
  integer :: i, j

contains

  function a_plus_b()
    ! Test to verify module-level variables work
    real(kind=jprb) :: a_plus_b
    a_plus_b = a + b
  end function a_plus_b

  function a_times_b_plus_c(a, b, c)
    ! Simple test to verify that module functions work
    real(kind=jprb) :: a_times_b_plus_c
    real(kind=jprb), intent(in) :: a, b, c
    a_times_b_plus_c = a * b + c
  end function a_times_b_plus_c

end module base

module ext_kernel_mod
  integer, parameter :: jprb = 4

contains

  subroutine ext_kernel(vector, matrix)
    real(kind=jprb), intent(inout) :: vector(:)
    real(kind=jprb), intent(inout) :: matrix(:, :)
    integer :: i

    do i = 1, size(vector)
      matrix(:, i) = matrix(:, i) + vector(i)
    end do
  end subroutine ext_kernel

end module ext_kernel_mod

module types
    use sub_types, only: sub_type

    implicit none

    public parent_type
    
    type parent_type
        integer :: member
        type(sub_type) :: type_member
    end type parent_type

end module

module driver

    use kernel, only: kernel_routine
    use types, only: parent_type

    contains

    subroutine driver_routine()
        type(parent_type) :: pt

        integer :: summed, i, size

        size = 100

        pt%member = 12
        ALLOCATE(pt%type_member%x(size))
        do i=1,size
            pt%type_member%x(i) = 1
        end do

        call kernel_routine(size, pt)

        summed = 0
        do i=1,size
            summed = summed + pt%type_member%x(i)
        end do

        print*, "the sum is", summed

    end subroutine driver_routine

end module driver

module driverB_mod
  use header_mod, only: jprb, header_type
  use kernelB_mod, only: kernelB

  implicit none

contains

  subroutine driverB()
    type(header_type) :: mystruct

    call kernelB(mystruct%vector, mystruct%matrix)

  end subroutine driverB

end module driverB_mod

program phys_layout

use omp_lib

use phys_mod, only: ip, lp, &
 &                  phys_kernel_LITE_LOOP, phys_kernel_VERT_SEARCH, phys_kernel_NASTY_EXPS, &
 &                  phys_kernel_LU_SOLVER, phys_kernel_LU_SOLVER_COMPACT

implicit none

!! arrays for passing to subroutine
real(kind=lp),dimension(:,:,:),allocatable :: arr1, arr2, arr3, arr4, arr5, arr6, arr7, arr8, arr9, arr10
real(kind=lp),dimension(:,:,:),allocatable :: out1 

integer(kind=ip) :: nproma, npoints, nlev, nblocks, ntotal, num_main_loops
integer(kind=ip) :: nb, nml, inp, i, i1, i2, k, real_bytes, tid

integer :: i_seed
integer, dimension(:), allocatable :: a_seed

integer :: iargs, lenarg
character(len=20) :: clarg

real(kind=lp) :: time1, time2

! Constants
nlev    = 137
num_main_loops = 8

! Defaults
nproma = 32
ntotal = 32*4096

iargs = command_argument_count()
if (iargs >= 1) then
   call get_command_argument(1, clarg, lenarg)
   read(clarg(1:lenarg),*) nproma

   if (iargs >= 2) then
      call get_command_argument(2, clarg, lenarg)
      read(clarg(1:lenarg),*) ntotal
   endif
endif
npoints = nproma  ! Can be unlocked later...
nblocks = ntotal / nproma + 1
write(*, '(A8,I8,A8,I8,A8,I8,A)') 'NPROMA ', nproma, "TOTAL ", ntotal, "NBLOCKS", nblocks

#ifdef FLOAT32
real_bytes = 4
#else
real_bytes = 8
#endif 

allocate(arr1 (npoints,nlev,nblocks))
allocate(arr2 (npoints,nlev,nblocks))
allocate(arr3 (npoints,nlev,nblocks))
allocate(arr4 (npoints,nlev,nblocks))
allocate(arr5 (npoints,nlev,nblocks))
allocate(arr6 (npoints,nlev,nblocks))
allocate(arr7 (npoints,nlev,nblocks))
allocate(arr8 (npoints,nlev,nblocks))
allocate(arr9 (npoints,nlev,nblocks))
allocate(arr10(npoints,nlev,nblocks))
allocate(out1 (npoints,nlev,nblocks))

! ----- Set up random seed portably -----
call random_seed(size=i_seed)
allocate(a_seed(1:i_seed))
call random_seed(get=a_seed)
a_seed = [ (i,i=1,i_seed) ]
call random_seed(put=a_seed)
deallocate(a_seed)

! Initialize values in parallel region to avoid accidental
! NUMA issues in single-socket mode on dual-socket machines.
!$omp parallel

!$omp master
do inp = 1, ntotal, nproma
  nb = (inp-1) / nproma + 1
  call random_number(arr1(:,:,nb))
  call random_number(arr2(:,:,nb))
  call random_number(arr3(:,:,nb))
  call random_number(arr4(:,:,nb))
  call random_number(arr5(:,:,nb))
  call random_number(arr6(:,:,nb))
  call random_number(arr7(:,:,nb))
  call random_number(arr8(:,:,nb))
  call random_number(arr9(:,:,nb))
  call random_number(arr10(:,:,nb))
end do
!$omp end master

! Pre-processor fudging to inject the relevant kernel call
#ifdef LITE_LOOP
#define PHYS_KERNEL phys_kernel_LITE_LOOP
#elif VERT_SEARCH
#define PHYS_KERNEL phys_kernel_VERT_SEARCH
#elif NASTY_EXPS
#define PHYS_KERNEL phys_kernel_NASTY_EXPS
#elif LU_SOLVER
#define PHYS_KERNEL phys_kernel_LU_SOLVER
#elif LU_SOLVER_COMPACT
#define PHYS_KERNEL phys_kernel_LU_SOLVER_COMPACT
#endif

time1 = omp_get_wtime()

do nml=1,num_main_loops

!$OMP PARALLEL DEFAULT(SHARED), PRIVATE(nb,inp,i1,i2)

! The classic BLOCKED-NPROMA structure from the IFS

!$omp do schedule(static)
do inp = 1, ntotal, nproma
  nb = (inp-1) / nproma + 1
  call PHYS_KERNEL( nproma, nlev, 1_ip, nproma, arr1(:,:,nb), arr2(:,:,nb), arr3(:,:,nb), &
 &                  arr4(:,:,nb), arr5(:,:,nb), &
 &                  arr6(:,:,nb), arr7 (:,:,nb), arr8(:,:,nb), &
 &                  arr9(:,:,nb), arr10(:,:,nb), out1(:,:,nb) )
end do
!$omp end do

!$OMP END PARALLEL

end do ! outer nml loop

time2 = omp_get_wtime()


write(*, '(A,3F12.6)') 'Result check : ', arr1(1,1,1), sum(arr1) / real(npoints*nlev*nblocks), sum(out1) / real(npoints*nlev*nblocks)
write(*, '(A,F8.4)') 'Time for kernel call : ', time2 - time1
write(*, '(A,F12.2,A,F12.2,A)') 'Bandwidth estimate : ', num_main_loops*11*npoints*nlev*nblocks*real_bytes*1.e-6, &
     ' MB transferred: ', num_main_loops*11*npoints*nlev*nblocks*real_bytes*1.e-6 / (time2-time1), ' MB/s '

! TODO: Should really dealloc all this stuff... :(

end program phys_layout

MODULE KERNEL_MOD
    IMPLICIT NONE
    CONTAINS
    SUBROUTINE kernel(start, iend, nlon, nz, q, t, z)
        INTEGER, INTENT(IN) :: start, iend  ! Iteration indices
        INTEGER, INTENT(IN) :: nlon, nz    ! Size of the horizontal and vertical
        REAL, INTENT(INOUT) :: t(nlon,nz)
        REAL, INTENT(INOUT) :: q(nlon,nz)
        REAL, INTENT(INOUT) :: z(nlon,nz)
        REAL    :: local_z(nlon, nz)
        INTEGER :: jl, jk
        REAL :: c

        c = 5.345
        DO jk = 2, nz
          DO jl = start, iend
            call ELEMENTAL_DEVICE(z(jl, jk))
          END DO
        END DO

        call DEVICE(nlon, nz, 2, start, iend, z)

        c = 5.345
        DO jk = 2, nz
          DO jl = start, iend
            t(jl, jk) = c * jk
            q(jl, jk) = q(jl, jk-1) + t(jl, jk) * c
          END DO
        END DO

        DO jk = 2, nz
          DO jl = start, iend
            local_z(jl, jk) = 0.0
            z(jl, jk) = local_z(jl, jk)
          END DO
        END DO

    END SUBROUTINE kernel

    PURE ELEMENTAL SUBROUTINE ELEMENTAL_DEVICE(x) ! elemental
      REAL, INTENT(INOUT) :: x
      x = 0.0
    END SUBROUTINE ELEMENTAL_DEVICE

    SUBROUTINE DEVICE(nlon, nz, jk_start, jl_start, jl_end, x)
        INTEGER, INTENT(IN) :: jk_start, jl_start, jl_end
        INTEGER, INTENT(IN) :: nlon, nz
        REAL, INTENT(INOUT) :: x(nlon, nz)
        REAL    :: local_x(nlon, nz)
        INTEGER :: jk, jl
        DO jk = jk_start, nz
            DO jl = jl_start, jl_end
                local_x(jl, jk) = 0.0
                x(jl, jk) = local_x(jl, jk)
            END DO
        END DO
    END SUBROUTINE DEVICE

END MODULE KERNEL_MOD

subroutine check_grade(score)
  integer, intent(in) :: score

  select case (score)
    case (90:100)
      print *, "A"
    case (80:89)
      print *, "B"
    case (70:79)
      print *, "C"
    case (60:69)
      print *, "D"
    case (0:59)
      print *, "F"
    case default
      print *, "Invalid score"
  end select

end subroutine check_grade

module subroutines_mod
    implicit none
    integer, parameter :: len = 3
contains

    subroutine kernel1(a, b, c)
        integer, intent(in) :: a
        integer, intent(inout) :: b(a)
        integer, intent(inout) :: c(a, len)
        real :: x(a)
        integer :: y(a, len)
        real :: k1_tmp(a, len)
        y = 11
        c = y
    end subroutine kernel1

    subroutine kernel2(a1, b)
        integer, intent(in) :: a1
        integer, intent(inout) :: b(a1)
        real :: x(a1)
        real :: y, z
        real :: k2_tmp(a1, a1)
        call device1(a1, b, x, k2_tmp)
        call device2(a1, b, x)
    end subroutine kernel2

    subroutine device1(a1, b, x, y)
        integer, intent(in) :: a1
        integer, intent(inout) :: b(a1)
        real, intent(inout) :: x(a1)
        real, intent(inout) :: y(a1, a1)
        real :: z
        integer :: d1_tmp
        call device2(a1, b, x)
        call device2(a1, b, x)
    end subroutine device1

    subroutine device2(a2, b, x)
        integer, intent(in) :: a2
        integer, intent(inout) :: b(a2)
        real, intent(inout) :: x(a2)
        integer z(a2)
        integer :: d2_tmp(len)
        z = 42
        b = z
    end subroutine device2

end module subroutines_mod

MODULE KERNEL_B_MOD
USE VAR_MODULE_MOD, only: n
IMPLICIT NONE
CONTAINS

  SUBROUTINE kernel_b(b, c)
    ! USE VAR_MODULE_MOD, only: n
    ! Second-level kernel call
    REAL, INTENT(INOUT)   :: b(:,:)
    REAL, INTENT(INOUT)   :: c(:,:)

  END SUBROUTINE kernel_b
END MODULE KERNEL_B_MOD

subroutine kernel0()
implicit none

  call kernel1()
  call kernel2()
  call kernel3()

end subroutine kernel0

subroutine kernel1()
use moduleA, only: var0,var1,some_func
implicit none
real :: tmp

tmp = var0 + var1 + some_func()

end subroutine kernel1

subroutine kernel2()
use moduleB, only: var2,var3
implicit none
real :: tmp

tmp = var2 + var3

end subroutine kernel2

subroutine kernel3()
use moduleB, only: var2,var3
use moduleC, only: var4,var5
implicit none

var4 = var2
var5 = var3

end subroutine kernel3

module sourcefile_cpp_stmt_func_mod

    IMPLICIT NONE

    ! originally declared in parkind1.F90
    INTEGER, PARAMETER :: JPIM = SELECTED_INT_KIND(9)
    INTEGER, PARAMETer :: JPRB = SELECTED_REAL_KIND(13,300)

contains

subroutine sourcefile_cpp_stmt_func(KIDIA, KFDIA, KLON, KLEV, ZFOEEW)
    INTEGER(KIND=JPIM),INTENT(IN)    :: KLON, KLEV
    INTEGER(KIND=JPIM),INTENT(IN)    :: KIDIA 
    INTEGER(KIND=JPIM),INTENT(IN)    :: KFDIA 
    REAL(KIND=JPRB)   ,INTENT(OUT)   :: ZFOEEW(KLON,KLEV)

    INTEGER(KIND=JPIM) :: JK, JL

    REAL(KIND=JPRB) :: ZTP1(KLON,KLEV)   
    REAL(KIND=JPRB) :: PAP(KLON,KLEV)
    REAL(KIND=JPRB) :: ZALFA

    ! originally declared in yomcst.F90
    REAL(KIND=JPRB) :: RTT = 1._JPRB

    ! originally declared in yoethf.F90
    REAL(KIND=JPRB) :: R2ES = 2._JPRB
    REAL(KIND=JPRB) :: R3LES = 3._JPRB
    REAL(KIND=JPRB) :: R3IES = 3._JPRB
    REAL(KIND=JPRB) :: R4LES = 4._JPRB
    REAL(KIND=JPRB) :: R4IES = 4._JPRB

#include "stmt.func.h"

    ! initialize with some stupid values
    PAP(:,:) = 8._JPRB
    ZTP1(:,:) = 1._JPRB

    DO JK=1,KLEV
        DO JL=KIDIA,KFDIA
            ZALFA=FOEDELTA(ZTP1(JL,JK))

            ! this should essentially become: min((zalfa * 2 + (1-zalfa) * 2))/8,0.5) === 0.25
            ZFOEEW(JL,JK)=MIN((ZALFA*FOEELIQ(ZTP1(JL,JK))+ &
                &  (1.0_JPRB-ZALFA)*FOEEICE(ZTP1(JL,JK)))/PAP(JL,JK),0.5_JPRB)
        END DO
    END DO
end subroutine sourcefile_cpp_stmt_func

end module sourcefile_cpp_stmt_func_mod

module kernelE_mod
  use header_mod, only: jprb
  use compute_l1_mod, only: compute_l1

  implicit none

contains

  ! Two kernel routines, but we process only one!

  subroutine kernelE(vector, matrix)
    real(kind=jprb), intent(inout) :: vector(:)
    real(kind=jprb), intent(inout) :: matrix(:)

    call compute_l1(vector)

    call ghost_busters(vector)

  contains

    subroutine ghost_busters(vector)
      real(kind=jprb), intent(inout) :: vector(:)

      vector(:) = 42.0
    end subroutine ghost_busters

  end subroutine kernelE

  subroutine kernelET(vector, matrix)
    real(kind=jprb), intent(inout) :: vector(:)
    real(kind=jprb), intent(inout) :: matrix(:)

    call compute_l2(vector)

  end subroutine kernelET

end module kernelE_mod

module kernelB_mod
  use header_mod, only: jprb
  use compute_l1_mod, only: compute_l1
#ifdef HAVE_EXT_DRIVER_MODULE
  use ext_driver_mod, only: ext_driver
#endif

  implicit none

contains

  subroutine kernelB(vector, matrix)
    real(kind=jprb), intent(inout) :: vector(:)
    real(kind=jprb), intent(inout) :: matrix(:)

#ifndef HAVE_EXT_DRIVER_MODULE
#include "ext_driver.intfb.h"
#endif

    call compute_l1(vector)

    call ext_driver(matrix)
  end subroutine kernelB

end module kernelB_mod

subroutine comp1 (arg, val)
    use t_mod, only: t, nt1
    use header_mod
    implicit none
    type(t), intent(inout) :: arg
    real(kind=k), intent(inout) :: val(:)
    integer :: jnt1
#include "comp2.intfb.h"
    call arg%proc()
    call comp2(arg, val)
    call comp2(arg, val)  ! Twice to check we're not duplicating dependencies
    do jnt1=1,nt1
        call arg%no(jnt1)%way(.true.)
    end do
end subroutine comp1

module cpp_stmt_func_mod

    IMPLICIT NONE

    ! originally declared in parkind1.F90
    INTEGER, PARAMETER :: JPIM = SELECTED_INT_KIND(9)
    INTEGER, PARAMETer :: JPRB = SELECTED_REAL_KIND(13,300)

contains

subroutine cpp_stmt_func(KIDIA, KFDIA, KLON, KLEV, ZFOEEW)
    INTEGER(KIND=JPIM),INTENT(IN)    :: KLON, KLEV
    INTEGER(KIND=JPIM),INTENT(IN)    :: KIDIA
    INTEGER(KIND=JPIM),INTENT(IN)    :: KFDIA
    REAL(KIND=JPRB)   ,INTENT(OUT)   :: ZFOEEW(KLON,KLEV)

    INTEGER(KIND=JPIM) :: JK, JL

    REAL(KIND=JPRB) :: ZTP1(KLON,KLEV)
    REAL(KIND=JPRB) :: PAP(KLON,KLEV)
    REAL(KIND=JPRB) :: ZALFA

    ! originally declared in yomcst.F90
    REAL(KIND=JPRB) :: RTT = 1._JPRB

    ! originally declared in yoethf.F90
    REAL(KIND=JPRB) :: R2ES = 2._JPRB
    REAL(KIND=JPRB) :: R3LES = 3._JPRB
    REAL(KIND=JPRB) :: R3IES = 3._JPRB
    REAL(KIND=JPRB) :: R4LES = 4._JPRB
    REAL(KIND=JPRB) :: R4IES = 4._JPRB

#include "stmt.func.h"

    ! initialize with some stupid values
    PAP(:,:) = 8._JPRB
    ZTP1(:,:) = 1._JPRB

    DO JK=1,KLEV
        DO JL=KIDIA,KFDIA
            ZALFA=FOEDELTA(ZTP1(JL,JK))

            ! this should essentially become: min((zalfa * 2 + (1-zalfa) * 2))/8,0.5) === 0.25
            ZFOEEW(JL,JK)=MIN((ZALFA*FOEELIQ(ZTP1(JL,JK))+ &
                &  (1.0_JPRB-ZALFA)*FOEEICE(ZTP1(JL,JK)))/PAP(JL,JK),0.5_JPRB)
        END DO
    END DO
end subroutine cpp_stmt_func

end module cpp_stmt_func_mod

module kernel_mod
  use parkind1, only : jpim,jprb
  implicit none
contains
  subroutine some_kernel(n,vout,var_out,var_in,var_inout,b,l,h,y)
  
  integer(kind=jpim),intent(in)  :: n,l,b
  integer(kind=jpim),intent(in)  :: h
  real(kind=jprb),   intent(in )   ::   var_in   (n)
  real(kind=jprb),   intent(inout) ::   var_out  (n)
  real(kind=jprb),   intent(inout) ::   var_inout(n)
  real(kind=jprb),   intent(inout) ::   vout(n)
  real(kind=jprb),   intent(inout) ::      y(:)
  
  end subroutine some_kernel
end module kernel_mod

subroutine intent_test(m,n,var_in,var_out,var_inout,tendency_loc)
use parkind1, only : jpim,jprb
use kernel_mod, only: some_kernel
use yoecldp, only : nclv
implicit none

integer(kind=jpim),intent(in) :: m,n
integer(kind=jpim) :: i,j,k,h,l
real(kind=jprb),   intent(in )        :: var_in   (n,n,n)
real(kind=jprb),   target,intent(out) :: var_out  (n,n,n)
real(kind=jprb),   intent(inout)      :: var_inout(n,n,n)
real(kind=jprb), allocatable :: x(:),y(:)
real(kind=jprb), pointer :: vout(n)
type(state_type), intent (out) :: tendency_loc

allocate(x(n))
associate(mtmp=>m)
allocate(y(mtmp))
end associate

associate(mtmp=>n)
do k=1,mtmp
  do j=1,mtmp
    do i=1,mtmp  
      var_out(i,j,k) = 2._jprb
    enddo
 
    associate(mbuf=>mtmp) 
    var_out(m:mbuf,j,k) = var_in(m:mbuf,j,k)+var_inout(m:mbuf,j,k)+var_out(m:mbuf,j,k)
    end associate

    vout=>var_out(:,j,k)

    associate(vin=>mtmp)
    call some_kernel(vin,vout,vout,var_in(:,j,k),var_inout(:,j,k),1,h=vin,l=5,y=y)
    end associate

    nullify(vout)

    associate(vout=>tendency_loc%cld(:,j,k))

    associate(vin=>var_in(:,j,k))
    call some_kernel(mtmp,vout,var_out(:,j,k),vin,var_inout(:,j,k),1,h=mtmp,l=5,y=y)
    end associate

    end associate

    do i=1,mtmp
      var_inout(i,j,k) = var_out(i,j,k)
    enddo
  enddo
enddo
end associate

deallocate(x)
deallocate(y)

end subroutine intent_test

#ifdef HAVE_EXT_DRIVER_MODULE
module ext_driver_mod
  implicit none

contains
#endif

  subroutine ext_driver(vector, matrix)
    use ext_kernel_mod, only: jprb, ext_kernel
    implicit none
    real(kind=jprb), intent(inout) :: vector(:)
    real(kind=jprb), intent(inout) :: matrix(:, :)

    call ext_kernel(vector, matrix)
  end subroutine ext_driver

#ifdef HAVE_EXT_DRIVER_MODULE
end module ext_driver_mod
#endif

subroutine kernel_derived_type()
use module_derived_type, only: p,p0,g,p_array
implicit none
integer :: i,j

do i=1,p%n
  p%x(i) = p0%x(i)
  p%y(i) = p0%y(i)
  p%z(i) = p0%z(i)
  do j=1,p%n
    p_array(i)%x(j) = 1.
    p_array(i)%y(j) = 2.
    p_array(i)%z(j) = 3.
  enddo
enddo

end subroutine kernel_derived_type

module typebound_header
    implicit none

    type header_type
    contains
        procedure :: member_routine => header_member_routine
        procedure :: routine_real => header_routine_real
        procedure :: routine_integer
        generic :: routine => routine_real, routine_integer
    end type header_type

contains

    subroutine header_member_routine(self, val)
        class(header_type) :: self
        integer, intent(in) :: val
        integer :: j
        j = val
    end subroutine header_member_routine

    subroutine header_routine_real(self, val)
        class(header_type) :: self
        real, intent(out) :: val
        val = 1.0
    end subroutine header_routine_real

    subroutine routine_integer(self, val)
        class(header_type) :: self
        integer, intent(out) :: val
        val = 1
    end subroutine routine_integer

    SUBROUTINE ABOR1(CDTEXT)
        CHARACTER(LEN=*) CDTEXT
        WRITE(0,*) CDTEXT
        call abort()
    END SUBROUTINE ABOR1
end module typebound_header

module KERNELA_MOD
  use header_mod, only: jprb
  use compute_l1_mod, only: compute_l1

  implicit none

contains

  subroutine KERNELA(vector, matrix)
    real(kind=jprb), intent(inout) :: vector(:)
    real(kind=jprb), intent(inout) :: matrix(:)

#include "another_l1.intfb.h"

    call COMPUTE_L1(vector)

    call ANOTHER_L1(matrix)

  end subroutine KERNELA

end module KERNELA_MOD

module driverA_mod
  use header_mod, only: jprb, header_type
  use kernelA_mod, only: kernelA

  implicit none

contains

  subroutine driverA()
    type(header_type) :: mystruct

    call kernelA(mystruct%vector, mystruct%matrix)

  end subroutine driverA

end module driverA_mod

module tt_mod
    use header_mod, only: k
    implicit none

    integer, parameter :: nclv = 5

    type tt
        real(kind=k), allocatable :: indirection(:)
        real(kind=k) :: other(nclv)
    contains
        procedure :: proc
    end type tt
contains
    subroutine proc(this)
        class(tt), intent(inout) :: this
    end subroutine proc
end module tt_mod

module driverD_mod
  use header_mod, only: jprb, header_type
  use kernelD_mod, only: kernelD

  implicit none

contains

  subroutine driverD()
    type(header_type) :: mystruct

    call kernelD(mystruct%vector, mystruct%matrix)
  end subroutine driverD

end module driverD_mod

subroutine kernel0()
use func_mod, only: some_func
implicit none
  real a
  call kernel1()
  call kernel2()
  call kernel3()
  a = some_func()
end subroutine kernel0

subroutine kernel1()
use moduleA, only: var0,var1,some_func
implicit none
real :: tmp

tmp = var0 + var1 + some_func()

end subroutine kernel1

subroutine kernel2()
use moduleB, only: var2,var3
implicit none
real :: tmp

tmp = var2 + var3

end subroutine kernel2

subroutine kernel3()
use moduleB, only: var2,var3
use moduleC, only: var4,var5
implicit none

var4 = var2
var5 = var3

end subroutine kernel3

module kernelB_mod
  use header_mod, only: jprb
  use compute_l1_mod, only: compute_l1
  use ext_driver_mod, only: ext_driver

  implicit none

contains

  subroutine kernelB(vector, matrix)
    real(kind=jprb), intent(inout) :: vector(:)
    real(kind=jprb), intent(inout) :: matrix(:)

    call compute_l1(vector)

    call ext_driver(matrix)
  end subroutine kernelB

end module kernelB_mod

module module_derived_type

   type point
      integer :: n
      real, allocatable :: x(:)
      real, allocatable :: y(:)
      real, allocatable :: z(:)
   end type point

   type grid
      type(point), allocatable :: p(:)
   end type grid

   type(point) :: p, p0
   type(point), allocatable :: p_array(:)
   type(grid) :: g

end module module_derived_type

module driver_mod

use some_derived_type_mod, only: some_derived_type
use kernel_mod, only: kernel
implicit none

contains
  subroutine driver(z)
        integer, intent(in) :: z
        type(some_derived_type) :: t_io
        type(some_derived_type) :: t_in, t_out
        integer :: m, n
        integer :: i, j

        m = 100
        n = 10

        t_in%a = real(m-1)
        t_in%b = real(n-1)

        call kernel(m, n, t_io%a, t_io%b, t_in, t_out)

  end subroutine driver
end module driver_mod

subroutine routine_pp_directives
  print *,"Compiled ",__FILENAME__," on ",__DATE__
#define __FILENAME__ __FILE__
  print *,"This is ",__FILE__,__VERSION__
  y = __LINE__ * 5 + __LINE__
end subroutine routine_pp_directives

subroutine extended_fma(a, b, c, sum)
  ! Add number from an imported module
  use base, only: jprb, a_times_b_plus_c

  implicit none
  real(kind=jprb), intent(in) :: a, b, c
  real(kind=jprb), intent(out) :: sum

  sum = a_times_b_plus_c(a, b, c)
end subroutine extended_fma

subroutine driver(n, work)
  use some_module, only: return_one, some_var, add_args, some_type
  use vars_module, only: varA, varB
  implicit none

  interface
     real function double_real(i)
       integer, intent(in) :: i
     end function double_real
  end interface

  integer, intent(in) :: n
  real, intent(out) :: work(n)
  type(some_type) :: var
  integer :: i

  do i=1,n
    work(i) = double_real(i) + return_one()
    work(i) = work(i) + dble(some_var)
    work(i) = work(i) + add_args(i,1) + add_args(i,2)
    call var%do_something(work(i))
  enddo

end subroutine driver

module kernel_mod

use some_derived_type_mod, only: some_derived_type
implicit none

contains

  subroutine kernel(m, n, P_a, P_b, Q, R)
        integer                , intent(in)    :: m, n
        real, intent(inout)                    :: P_a, P_b
        type(some_derived_type), intent(in)    :: Q
        type(some_derived_type), intent(out)   :: R
        integer :: j, k

        R%a = P_a + Q%a
        R%b = P_b - Q%b
  end subroutine kernel

end module kernel_mod

module compute_l2_mod
  use header_mod, only: jprb

contains

  subroutine compute_l2(vector)
    real(kind=jprb), intent(inout) :: vector(:)

    vector(:) = 66.0

  end subroutine compute_l2

end module compute_l2_mod

module compute_l1_mod
  use header_mod, only: jprb
  use compute_l2_mod, only: compute_l2

contains

  subroutine compute_l1(vector)
    real(kind=jprb), intent(inout) :: vector(:)

    call compute_l2(vector)

  end subroutine compute_l1

end module compute_l1_mod

module driver_0_mod
  implicit none
contains

   subroutine driver_0()
#include "subroutine_1.intfb.h"
#include "subroutine_3.intfb.h"
     call subroutine_1()
     call subroutine_3()
     call subroutine_3()
   end subroutine driver_0
end module driver_0_mod

subroutine SimpleDependency(data, n)
  implicit none
  integer, intent(in) :: n
  real(8), dimension(n) :: data
  integer :: i

  ! Loop with a simple loop-carried dependency
  do i = 1, n
    data(i) = data(i) + data(i-1)
  end do

end subroutine SimpleDependency


subroutine NestedDependency(data, n)
  implicit none
  integer, intent(in) :: n
  real(8), dimension(n) :: data
  integer :: i, j

  ! Nested loop with a loop-carried dependency
  do i = 2, n
    do j = 1, i-1
      data(i) = data(i) + data(j)
    end do
  end do

end subroutine NestedDependency


subroutine ConditionalDependency(data, n)
  implicit none
  integer, intent(in) :: n
  real(8), dimension(n) :: data
  integer :: i

  ! Loop with a conditional loop-carried dependency
  do i = 2, n
    if (data(i-1) > 0.0) then
      data(i) = data(i) + data(i-1)
    endif
  end do

end subroutine ConditionalDependency

subroutine NoDependency(data)
  implicit none
  real(8), dimension(20) :: data
  integer :: i

  do i = 1, 10, 1
    data(2*i) = 10;
  end do

  do i = 1, 5, 1
    data(2*i + 1) = 20;
  end do
end subroutine NoDependency

module t_mod
    use tt_mod, only: tt
    use a_mod, only: a
    implicit none

    integer, parameter :: nt1 = 10

    type t1
    contains
        procedure :: way => my_way
    end type t1

    type t
        type(tt) :: yay
        type(t1) :: no(nt1)
    contains
        procedure :: proc => t_proc
    end type t
contains
    subroutine t_proc(this)
        class(t), intent(inout) :: this
        call a(this%yay%other)
        call this%yay%proc()
    end subroutine t_proc

    recursive subroutine my_way(this, recurse)
        class(t1), intent(inout) :: this
        logical, intent(in) :: recurse
        if (recurse) call this%way(.false.)
    end subroutine my_way
end module t_mod

subroutine nested_if_example(x, y)
  integer, intent(in) :: x, y

  if (x > 0) then
    if (y > 0) then
      print *, "Both x and y are positive."
    else
      print *, "x is positive, but y is not."
    end if
  else
    if (y > 0) then
      print *, "x is not positive, but y is positive."
    else
      print *, "Both x and y are not positive."
    end if
  end if

end subroutine nested_if_example

MODULE driver_mod
    USE KERNEL_MOD, ONLY: KERNEL
    IMPLICIT NONE
CONTAINS
    SUBROUTINE driver(nlon, nz, nb, tot, q, t, z)
        INTEGER, INTENT(IN)   :: nlon, nz, nb  ! Size of the horizontal and vertical
        INTEGER, INTENT(IN)   :: tot
        REAL, INTENT(INOUT)   :: t(nlon,nz,nb)
        REAL, INTENT(INOUT)   :: q(nlon,nz,nb)
        REAL, INTENT(INOUT)   :: z(nlon,nz+1,nb)
        INTEGER :: b, start, iend, ibl, icend

        start = 1
        iend = tot
        do b=1,iend,nlon
          ibl = (b-1)/nlon+1
          icend = MIN(nlon,tot-b+1)
          call kernel(start, icend, nlon, nz, q(:,:,b), t(:,:,b), z(:,:,b))
        end do

        do b=1,iend,nlon
          ibl = (b-1)/nlon+1
          icend = MIN(nlon,tot-b+1)
          call kernel(start, icend, nlon, nz, q(:,:,b), t(:,:,b), z(:,:,b))
          call kernel(start, icend, nlon, nz, q(:,:,b), t(:,:,b), z(:,:,b))
        end do

    END SUBROUTINE driver
END MODULE driver_mod

subroutine loop_fuse(n,var_in,var_out)
use parkind1, only : jpim,jprb
implicit none

integer(kind=jpim),intent(in) :: n
real(kind=jprb),   intent(in ) :: var_in (n,n,n)
real(kind=jprb),   intent(out) :: var_out(n,n,n)
integer(kind=jpim) :: i,j,k

do k=1,n
  do j=1,n
    do i=1,n
      var_out(i,j,k) = var_in(i,j,k)
    enddo
    do i=1,n   
      var_out(i,j,k) = 2._JPRB*var_out(i,j,k)
    enddo
  enddo
enddo

end subroutine loop_fuse

subroutine loop_fuse_v1(n,var_in,var_out)
use parkind1, only : jpim,jprb
implicit none

integer(kind=jpim),intent(in) :: n
real(kind=jprb),   intent(in ) :: var_in (n,n,n)
real(kind=jprb),   intent(out) :: var_out(n,n,n)
integer(kind=jpim) :: i,j,k

do k=1,n
  do j=1,n
    do i=1,n
      var_out(i,j,k) = var_in(i,j,k)
    enddo
    do i=1,n   
      var_out(i,j,k) = 2._JPRB*var_out(i,j,k)
    enddo
  enddo

  call some_kernel(n,var_out(1,1,k))

  do j=1,n
    do i=1,n
      var_out(i,j,k) = var_out(i,j,k) + 1._JPRB
    enddo
    do i=1,n   
      var_out(i,j,k) = 2._JPRB*var_out(i,j,k)
    enddo
  enddo
enddo

end subroutine loop_fuse_v1

subroutine loop_fuse_v2(n,var_in,var_out)
use parkind1, only : jpim,jprb
implicit none

integer(kind=jpim),intent(in) :: n
real(kind=jprb),   intent(in ) :: var_in (n,n,n)
real(kind=jprb),   intent(out) :: var_out(n,n,n)
integer(kind=jpim) :: i,j,k

do k=1,n
  do j=1,n
    do i=1,n
      var_out(i,j,k) = var_in(i,j,k)
    enddo
    do i=1,n   
      var_out(i,j,k) = 2._JPRB*var_out(i,j,k)
    enddo

    call some_kernel(n,var_out(1,j,k))

    do i=1,n
      var_out(i,j,k) = var_out(i,j,k) + 1._JPRB
    enddo
    do i=1,n   
      var_out(i,j,k) = 2._JPRB*var_out(i,j,k)
    enddo
  enddo
enddo

end subroutine loop_fuse_v2

subroutine loop_fuse_pragma(n,var_in,var_out)
use parkind1, only : jpim,jprb
implicit none

integer(kind=jpim),intent(in) :: n
real(kind=jprb),   intent(in ) :: var_in (n,n,n)
real(kind=jprb),   intent(out) :: var_out(n,n,n)
integer(kind=jpim) :: i,j,k

do k=1,n
  do j=1,n

    !$loki loop-fusion group(g1)
    do i=1,n
      var_out(i,j,k) = var_in(i,j,k)
    enddo
    !$loki loop-fusion group(g1)
    do i=1,n   
      var_out(i,j,k) = 2._JPRB*var_out(i,j,k)
    enddo

    call some_kernel(n,var_out(1,j,k))

    !$loki loop-fusion group(g2)
    do i=1,n
      var_out(i,j,k) = var_out(i,j,k) + 1._JPRB
    enddo
    !$loki loop-fusion group(g2)
    do i=1,n   
      var_out(i,j,k) = 2._JPRB*var_out(i,j,k)
    enddo
    
  enddo
enddo

end subroutine loop_fuse_pragma

subroutine routine_a
integer a
a = 1
end subroutine routine_a

module some_module
contains
subroutine module_routine
integer m
m = 2
end subroutine module_routine
function module_function(n)
integer n
n = 3
end function module_function
end module some_module

subroutine routine_b
integer b
b = 4
contains
subroutine contained_c
integer c
c = 5
end subroutine contained_c
end subroutine routine_b

function function_d(d)
integer d
d = 6
end function function_d

module ext_driver_mod
  use ext_kernel_mod, only: jprb, ext_kernel

contains

  subroutine ext_driver(vector, matrix)
    real(kind=jprb), intent(inout) :: vector(:)
    real(kind=jprb), intent(inout) :: matrix(:, :)

    call ext_kernel(vector, matrix)
  end subroutine ext_driver

end module ext_driver_mod

module typebound_other
    use typebound_header, header => header_type

    implicit none

    type other_type
      type(header) :: var(2)
    contains
      procedure :: member => other_member
    end type other_type

contains

    module subroutine other_member(self, i, m)
        use typebound_header, only: member_routine => header_member_routine
        class(other_type) :: self
        integer, intent(in) :: i, m
        call member_routine(m)
        call self%var(i)%member_routine(m)
    end subroutine other_member

end module typebound_other

module phys_mod

use :: iso_fortran_env

use omp_lib

implicit none

integer, parameter :: sp = REAL32
integer, parameter :: dp = REAL64
#ifdef FLOAT_SINGLE
integer, parameter :: lp = sp     !! lp : "local" precision
#else
integer, parameter :: lp = dp     !! lp : "local" precision
#endif

integer, parameter :: ip = INT64

real(kind=lp) :: cst1 = 2.5, cst2 = 3.14
integer, parameter :: nspecies = 5

contains 

subroutine phys_kernel_LITE_LOOP(dim1,dim2,i1,i2, in1,in2,in3,in4,in5,in6,in7,in8,in9,in10, out1)
  integer(kind=ip),intent(in) :: dim1, dim2, i1,i2
  real(kind=lp),dimension(1:dim1,1:dim2),intent(inout) :: in1,in2,in3,in4,in5,in6,in7,in8,in9,in10
  real(kind=lp),dimension(1:dim1,1:dim2),intent(inout) :: out1

  integer(kind=ip) :: i,k
  do k=1,dim2
    do i=i1,i2
      out1(i,k) = (in1(i,k) + in2(i,k) + in3(i,k) + in4(i,k) + in5(i,k) + &
 &                 in6(i,k) + in7(i,k) + in8(i,k) + in9(i,k) + in10(i,k)) * 0.1
      in1(i,k) = out1(i,k)
    end do
  end do
end subroutine phys_kernel_LITE_LOOP

subroutine phys_kernel_VERT_SEARCH(dim1,dim2,i1,i2, in1,in2,in3,in4,in5,in6,in7,in8,in9,in10, out1)
  integer(kind=ip),intent(in) :: dim1, dim2, i1,i2
  real(kind=lp),dimension(1:dim1,1:dim2),intent(inout) :: in1,in2,in3,in4,in5,in6,in7,in8,in9,in10
  real(kind=lp),dimension(1:dim1,1:dim2),intent(inout) :: out1

  integer(kind=ip) :: i,k
  real(kind=lp) :: temp(i1:i2)
  integer :: kmax(i1:i2)

  temp = -1.
  kmax = -1
  do k=1,dim2
    do i=i1,i2
      if (in1(i,k) > temp(i)) then
        temp(i) = in1(i,k)
        kmax(i) = k
      end if
    end do
  end do

  do i=i1,i2
    do k=1,kmax(i)
      out1(i,k) = (in1(i,k) + in2(i,k) + in3(i,k) + in4(i,k) + in5(i,k) + &
 &                 in6(i,k) + in7(i,k) + in8(i,k) + in9(i,k) + in10(i,k)) * 0.1
      in1(i,k) = out1(i,k)
    end do
  end do
  
  do i=i1,i2
    do k=kmax(i)+1,dim2
      out1(i,k) = (in1(i,k) * in2(i,k) * in3(i,k) * in4(i,k) * in5(i,k) + &
 &                 in6(i,k) * in7(i,k) * in8(i,k) * in9(i,k) * in10(i,k)) * 0.3
      in1(i,k) = out1(i,k)
    end do
  end do
end subroutine phys_kernel_VERT_SEARCH

subroutine phys_kernel_NASTY_EXPS(dim1,dim2,i1,i2, in1,in2,in3,in4,in5,in6,in7,in8,in9,in10, out1)
  integer(kind=ip),intent(in) :: dim1, dim2, i1,i2
  real(kind=lp),dimension(1:dim1,1:dim2),intent(inout) :: in1,in2,in3,in4,in5,in6,in7,in8,in9,in10
  real(kind=lp),dimension(1:dim1,1:dim2),intent(inout) :: out1

  integer(kind=ip) :: i,k
  real(kind=lp) :: temp_s1, temp_s2

  do k=1,dim2
    do i=i1,i2
      temp_s1 = (in1(i,k) + in2(i,k) + in3(i,k) + in4(i,k) + in5(i,k) + &
 &                 in6(i,k) + in7(i,k) + in8(i,k) + in9(i,k) + in10(i,k)) * 0.1
      temp_s1 = min( exp( (temp_s1 - cst1) / (temp_s1 - cst2) ), exp(in4(i,k)-in5(i,k)) )

      temp_s2 = (in1(i,k) - in2(i,k) * in3(i,k) - in4(i,k) + (in5(i,k) - &
 &                 in6(i,k)*0.5) + (in7(i,k) - in8(i,k)*0.1) - in9(i,k) - in10(i,k)) * 0.2
      temp_s2 = min( exp( (temp_s2 - cst2) / (temp_s2 - cst1) ), exp(in6(i,k)+in7(i,k)) )

      if (temp_s1 < temp_s2) then
        out1(i,k) = temp_s1
      else 
        out1(i,k) = temp_s2
      end if

      in1(i,k) = out1(i,k)
    end do
  end do
end subroutine phys_kernel_NASTY_EXPS

subroutine phys_kernel_LU_SOLVER(dim1,dim2,i1,i2, in1,in2,in3,in4,in5,in6,in7,in8,in9,in10, out1)
  integer(kind=ip),intent(in) :: dim1, dim2, i1,i2
  real(kind=lp),dimension(1:dim1,1:dim2),intent(inout) :: in1,in2,in3,in4,in5,in6,in7,in8,in9,in10
  real(kind=lp),dimension(1:dim1,1:dim2),intent(inout) :: out1

  integer(kind=ip) :: i,k
  real(kind=lp),dimension(dim1,nspecies,nspecies) :: lu_lhs, lu_rhs_implicit
  integer(kind=ip) :: s1,s2,s3, jm,jn
  real(kind=lp) :: dp(i1:i2), temp_hor1(i1:i2)
  real(kind=lp) :: temp_out(i1:i2,nspecies), out_lev_m_1(i1:i2,nspecies)

  ! initialise for k=1
  out_lev_m_1 = 0.

  do k=1,dim2
 
    do i=i1,i2
      lu_rhs_implicit(i,:,:) = 0.5
      lu_lhs(i,:,:) = 0.1
    end do

    if (k<dim2) then
      do i=i1,i2
        dp(i) = in2(i,k+1)-in2(i,k)
      end do
    else
      do i=i1,i2
        dp(i) = 1.0
      end do
    end if

    do i=i1,i2
      temp_hor1(i) = in1(i,k)*in2(i,k) + in5(i,k)/in6(i,k)
      temp_hor1(i) = temp_hor1(i) - floor(temp_hor1(i))
    end do

    do i=i1,i2
      lu_rhs_implicit(i,2,2) = (in4(i,k+1) + in7(i,k+1)) * dp(i) !! diagonal term, are NCLDQL & NCLDQI consecutive? shouldn't really matter as long as diag is non-zero
      lu_rhs_implicit(i,4,4) = (in4(i,k+1) + in7(i,k+1)) * dp(i) !! idem 
    end do

    ! modify local value of rhs_impl based on some local input value like temperature
    do i=i1,i2
      if (in3(i,k) < 0.1) then
        lu_rhs_implicit(i,2,4) = lu_rhs_implicit(i,2,4) + in7(i,k) 
        lu_rhs_implicit(i,3,4) = lu_rhs_implicit(i,3,4) + in9(i,k) 
      end if
    end do

    ! modify value of rhs_impl based on local derived value 
    do i=i1,i2
      if (temp_hor1(i) > 0.8) then
        lu_rhs_implicit(i,1,4) = lu_rhs_implicit(i,1,4) + in6(i,k) 
        lu_rhs_implicit(i,3,4) = lu_rhs_implicit(i,3,4) + in8(i,k) 
      end if
    end do

    ! set up lhs properly
    do s2=1,nspecies
      do s1=1,nspecies
        if (s1==s2) then
          do i=i1,i2
            lu_lhs(i,s1,s1) = lu_lhs(i,s1,s1) + sum(lu_rhs_implicit(i,:,s1))  ! diagonal term 
          end do
        else 
          do i=i1,i2
            lu_lhs(i,s1,s2) = - lu_rhs_implicit(i,s1,s2) ! off-diagonal
          end do
        end if
      end do ! s1
    end do ! s2

    ! set the rhs hopefully plausibly 
    do s2=1,nspecies 
      do i=i1,i2
        if (s2==1) then
          temp_out(i,s2)= in1(i,k) + in9(i,k) ! zexplicit
        elseif (s2==2) then
          temp_out(i,s2)= in2(i,k) + in9(i,k) ! zexplicit
        elseif (s2==3) then
          temp_out(i,s2)= in3(i,k) + in9(i,k) ! zexplicit
        elseif (s2==4) then
          temp_out(i,s2)= in4(i,k) + in9(i,k) ! zexplicit
        elseif (s2==5) then
          temp_out(i,s2)= in5(i,k) + in9(i,k) ! zexplicit
        end if
      enddo
    enddo

    ! following factorization code taken straight from CLOUDSC
    ! Non pivoting recursive factorization 
    do s2 = 1, nspecies-1
      do s1 = s2+1,nspecies
        do i=i1,i2
          lu_lhs(i,s1,s2)=lu_lhs(i,s1,s2) / lu_lhs(i,s2,s2)
        enddo
        do s3=s2+1,nspecies
          do i=i1,i2
            lu_lhs(i,s1,s3)=lu_lhs(i,s1,s3)-lu_lhs(i,s1,s2)*lu_lhs(i,s2,s3)
          enddo ! do i
        enddo ! do s3
      enddo ! do s1
    enddo ! do s2

    ! backsubstitution 
    !  step 1 
    do s2=2,nspecies
      do s1 = 1,s2-1
        do i=i1,i2
          temp_out(i,s2)=temp_out(i,s2)-lu_lhs(i,s2,s1) * temp_out(i,s1)
        end do !  i
      end do ! s1
    end do ! s2
    !  step 2
    do i=i1,i2
      temp_out(i,nspecies)=temp_out(i,nspecies)/lu_lhs(i,nspecies,nspecies)
    end do !  i
    do s2=nspecies-1,1,-1
      do s1 = s2+1,nspecies
        do i=i1,i2
          temp_out(i,s2)=temp_out(i,s2)-lu_lhs(i,s2,s1) * temp_out(i,s1)
        end do !  i
      end do ! s1
      do i=i1,i2
        temp_out(i,s2)=temp_out(i,s2)/lu_lhs(i,s2,s2)
      end do !  i
    enddo ! s2

    ! extract solution values into output
    do i=i1,i2
      out1(i,k) = sum(temp_out(i,:))
    end do
    ! save k level values for use at k+1
    do s1=1,nspecies
      do i=i1,i2
        out_lev_m_1(i,s1) = temp_out(i,s1)
      end do ! i
    end do ! s1

  end do !! do k

end subroutine phys_kernel_LU_SOLVER

subroutine phys_kernel_LU_SOLVER_COMPACT(dim1,dim2,i1,i2, in1,in2,in3,in4,in5,in6,in7,in8,in9,in10, out1)
  ! To satisfy my curiosity, flip the allocation of the matrix to be compact for each grid point.
  integer(kind=ip),intent(in) :: dim1, dim2, i1,i2
  real(kind=lp),dimension(1:dim1,1:dim2),intent(inout) :: in1,in2,in3,in4,in5,in6,in7,in8,in9,in10
  real(kind=lp),dimension(1:dim1,1:dim2),intent(inout) :: out1

  integer(kind=ip) :: i,k
  ! Invert the matrix allocation, so that parallel dim is outermost
  real(kind=lp),dimension(nspecies,nspecies,dim1) :: lu_lhs, lu_rhs_implicit
  integer(kind=ip) :: s1,s2,s3, jm,jn
  real(kind=lp) :: dp(i1:i2), temp_hor1(i1:i2)
  real(kind=lp) :: temp_out(i1:i2,nspecies), out_lev_m_1(i1:i2,nspecies)

  ! initialise for k=1
  out_lev_m_1 = 0.

  do k=1,dim2
 
    do i=i1,i2
      lu_rhs_implicit(:,:,i) = 0.5
      lu_lhs(:,:,i) = 0.1
    end do

    if (k<dim2) then
      do i=i1,i2
        dp(i) = in2(i,k+1)-in2(i,k)
      end do
    else
      do i=i1,i2
        dp(i) = 1.0
      end do
    end if

    do i=i1,i2
      temp_hor1(i) = in1(i,k)*in2(i,k) + in5(i,k)/in6(i,k)
      temp_hor1(i) = temp_hor1(i) - floor(temp_hor1(i))
    end do

    do i=i1,i2
      lu_rhs_implicit(2,2,i) = (in4(i,k+1) + in7(i,k+1)) * dp(i) !! diagonal term, are NCLDQL & NCLDQI consecutive? shouldn't really matter as long as diag is non-zero
      lu_rhs_implicit(4,4,i) = (in4(i,k+1) + in7(i,k+1)) * dp(i) !! idem 
    end do

    ! modify local value of rhs_impl based on some local input value like temperature
    do i=i1,i2
      if (in3(i,k) < 0.1) then
        lu_rhs_implicit(2,4,i) = lu_rhs_implicit(2,4,i) + in7(i,k) 
        lu_rhs_implicit(3,4,i) = lu_rhs_implicit(3,4,i) + in9(i,k) 
      end if
    end do

    ! modify value of rhs_impl based on local derived value 
    do i=i1,i2
      if (temp_hor1(i) > 0.8) then
        lu_rhs_implicit(1,4,i) = lu_rhs_implicit(1,4,i) + in6(i,k) 
        lu_rhs_implicit(3,4,i) = lu_rhs_implicit(3,4,i) + in8(i,k) 
      end if
    end do

    ! set up lhs properly
    do s2=1,nspecies
      do s1=1,nspecies
        if (s1==s2) then
          do i=i1,i2
            lu_lhs(s1,s1,i) = lu_lhs(s1,s1,i) + sum(lu_rhs_implicit(:,s1,i))  ! diagonal term 
          end do
        else 
          do i=i1,i2
            lu_lhs(s1,s2,i) = - lu_rhs_implicit(s1,s2,i) ! off-diagonal
          end do
        end if
      end do ! s1
    end do ! s2

    ! set the rhs hopefully plausibly 
    do s2=1,nspecies 
      do i=i1,i2
        if (s2==1) then
          temp_out(i,s2)= in1(i,k) + in9(i,k) ! zexplicit
        elseif (s2==2) then
          temp_out(i,s2)= in2(i,k) + in9(i,k) ! zexplicit
        elseif (s2==3) then
          temp_out(i,s2)= in3(i,k) + in9(i,k) ! zexplicit
        elseif (s2==4) then
          temp_out(i,s2)= in4(i,k) + in9(i,k) ! zexplicit
        elseif (s2==5) then
          temp_out(i,s2)= in5(i,k) + in9(i,k) ! zexplicit
        end if
      enddo
    enddo

    ! following factorization code taken straight from CLOUDSC
    ! Non pivoting recursive factorization 
    do s2 = 1, nspecies-1
      do s1 = s2+1,nspecies
        do i=i1,i2
          lu_lhs(s1,s2,i)=lu_lhs(s1,s2,i) / lu_lhs(s2,s2,i)
        enddo
        do s3=s2+1,nspecies
          do i=i1,i2
            lu_lhs(s1,s3,i)=lu_lhs(s1,s3,i)-lu_lhs(s1,s2,i)*lu_lhs(s2,s3,i)
          enddo ! do i
        enddo ! do s3
      enddo ! do s1
    enddo ! do s2

    ! backsubstitution 
    !  step 1 
    do s2=2,nspecies
      do s1 = 1,s2-1
        do i=i1,i2
          temp_out(i,s2)=temp_out(i,s2)-lu_lhs(s2,s1,i) * temp_out(i,s1)
        end do !  i
      end do ! s1
    end do ! s2
    !  step 2
    do i=i1,i2
      temp_out(i,nspecies)=temp_out(i,nspecies)/lu_lhs(nspecies,nspecies,i)
    end do !  i
    do s2=nspecies-1,1,-1
      do s1 = s2+1,nspecies
        do i=i1,i2
          temp_out(i,s2)=temp_out(i,s2)-lu_lhs(s2,s1,i) * temp_out(i,s1)
        end do !  i
      end do ! s1
      do i=i1,i2
        temp_out(i,s2)=temp_out(i,s2)/lu_lhs(s2,s2,i)
      end do !  i
    enddo ! s2

    ! extract solution values into output
    do i=i1,i2
      out1(i,k) = sum(temp_out(i,:))
    end do
    ! save k level values for use at k+1
    do s1=1,nspecies
      do i=i1,i2
        out_lev_m_1(i,s1) = temp_out(i,s1)
      end do ! i
    end do ! s1

  end do !! do k

end subroutine phys_kernel_LU_SOLVER_COMPACT

end module phys_mod

MODULE KERNEL_A1_MOD
IMPLICIT NONE
CONTAINS

  SUBROUTINE kernel_a1(b, c)
    ! Second-level kernel call
    REAL, INTENT(INOUT)   :: b(:,:)
    REAL, INTENT(INOUT)   :: c(:,:)

  END SUBROUTINE kernel_a1

END MODULE KERNEL_A1_MOD

module other_mod
    use tt_mod, only: tt
    use b_mod, only: b
    implicit none
contains
    subroutine mod_proc(arg)
        type(tt), intent(inout) :: arg
        call arg%proc()
        call b(arg%indirection)
    end subroutine mod_proc
end module other_mod

module subroutine_3_mod
implicit none
contains
subroutine subroutine_3()
  use nested_subroutine_1_mod, only: nested_subroutine_1
  use nested_subroutine_3_mod, only: nested_subroutine_3

  call nested_subroutine_1()
  call nested_subroutine_3()
end subroutine subroutine_3
end module subroutine_3_mod

module typebound_item
    use typebound_header
    implicit none

    type some_type
    contains
        procedure, nopass :: routine => module_routine
        procedure :: some_routine
        procedure, pass :: other_routine
        procedure :: routine1, &
            & routine2 => routine
        ! procedure :: routine1
        ! procedure :: routine2 => routine
    end type some_type
contains
    subroutine module_routine
        integer m
        m = 2
    end subroutine module_routine

    subroutine some_routine(self)
        class(some_type) :: self

        call self%routine
    end subroutine some_routine

    subroutine other_routine(self, m)
        class(some_type), intent(inout) :: self
        integer, intent(in) :: m
        integer :: j

        if (m < 0) call abor1('Error with unbalanced parenthesis)')

        j = m
        call self%routine1
        call self%routine2
    end subroutine other_routine

    subroutine routine(self)
        class(some_type) :: self
        call self%some_routine
    end subroutine routine

    subroutine routine1(self)
        class(some_type) :: self
        call module_routine
    end subroutine routine1
end module typebound_item

subroutine driver
    use typebound_item
    use typebound_header
    use typebound_other, only: other => other_type
    implicit none

    integer, parameter :: constant = 2
    type(some_type), allocatable :: obj(:), obj2(:,:)
    type(header_type) :: header
    type(other) :: other_obj, derived(constant)
    real :: x
    integer :: i

    allocate(obj(1))
    allocate(obj2(1,1))
    call obj(1)%other_routine(5)
    call obj2(1,1)%some_routine
    call header%member_routine(1)
    call header%routine(x)
    call header%routine(i)
    call other_obj%member(2, 2)
    call derived(1)% var( 2 ) % member_routine(2)
end subroutine driver

module kernelD_mod
  use header_mod, only: jprb
  use compute_l1_mod, only: compute_l1
  use proj_c_util_mod

  implicit none

contains

  subroutine kernelD(vector, matrix)
    real(kind=jprb), intent(inout) :: vector(:)
    real(kind=jprb), intent(inout) :: matrix(:)

    call compute_l1(vector)

    call routine_one(matrix)
  end subroutine kernelD

end module kernelD_mod

module typebound_other
    use typebound_header, only: header => header_type

    implicit none

    type other_type
      type(header) :: var(2)
    contains
      procedure :: member => other_member
    end type other_type

    type outer_type
      type(other_type) :: other
    contains
      procedure :: nested_call
    end type outer_type

contains

    module subroutine other_member(self, i, m)
        use typebound_header, only: member_routine => header_member_routine
        class(other_type) :: self
        integer, intent(in) :: i, m
        call member_routine(m)
        call self%var(i)%member_routine(m)
    end subroutine other_member

    subroutine nested_call(self, m)
      class(outer_type) :: self
      integer, intent(in) :: m
      call self%other%var(1)%member_routine(m)
      call self%other%var(2)%member_routine(m)
    end subroutine nested_call

end module typebound_other

module subroutine_1_mod
implicit none
contains
subroutine subroutine_1()
  use nested_subroutine_1_mod, only: nested_subroutine_1
  call nested_subroutine_1()
end subroutine subroutine_1
end module subroutine_1_mod

module subroutine_2_mod
implicit none
contains
subroutine subroutine_2()
  use nested_subroutine_2_mod, only: nested_subroutine_2
  use nested_subroutine_3_mod, only: nested_subroutine_3
  call nested_subroutine_2()
  call nested_subroutine_3()
end subroutine subroutine_2
end module subroutine_2_mod

module driver_1_mod
  implicit none
contains

   subroutine driver_1()
     use subroutine_1_mod, only: subroutine_1
     use subroutine_3_mod, only: subroutine_3
     call subroutine_1()
     call subroutine_3()
     call subroutine_3()
   end subroutine driver_1
end module driver_1_mod

```{toctree}
:hidden:

Home page <self>
getting_started
using_loki
loki_api
```

```{important}
Loki is still under active development and has not yet seen a stable
release. Interfaces can change at any time, objects may be renamed, or
concepts may be re-thought. Make sure to sync your work to the current
release frequently by rebasing feature branches and upstreaming
more general applicable work in the form of pull requests.
```

```{include} ../../README.md
```

## Indices and tables

- {ref}`genindex`
- {ref}`modindex`

# Installation

There are multiple different ways of installing Loki, tailored towards various
use-cases:

- via `pip install` as a pure Python package
- via the provided install script to ease the setup of optional dependencies
- via CMake/ecbuild to enable installation as part of a CMake project
- via ecbundle
- manually

Loki is a pure Python package that depends on a range of upstream packages. We
recommend to use a
[virtual environment](https://packaging.python.org/en/latest/guides/installing-using-pip-and-virtual-environments/#creating-a-virtual-environment)
to avoid conflicts with versions of system-wide installed packages. The
CMake/ecbuild installation method as well as the provided script `install` will
do this automatically.

## Requirements

- Python 3.8+ with virtualenv and pip
- For graphical output of Scheduler dependency graphs: graphviz

### Optional requirements

The following is required to use the Open Fortran Parser (OFP) or OMNI frontend or the CLAW compiler:

- JDK 1.8+ with ant (can be installed using the install script or ecbuild)
- libxml2 (with headers)

## Installation without prior download

The easiest way to obtain a useable installation of Loki with the fparser frontend does not
require downloading the source code. Simply run the following commands:

```bash
python3 -m venv loki_env  # Create a virtual environment
source loki_env/bin/activate  # Activate the virtual environment

# Installation of the Loki core library
pip install "loki @ git+https://github.com/ecmwf-ifs/loki.git"

# Optional: Installation of IFS lint rules for the use as a linter
pip install "lint_rules @ git+https://github.com/ecmwf-ifs/loki.git#subdirectory=lint_rules"
```

This makes the Python package available and installs the scripts `loki-transform.py` and `loki-lint.py` on the PATH.


## Installation from source

After downloading the source code, e.g., via

```bash
git clone https://github.com/ecmwf-ifs/loki.git
```

enter the created source directory and choose one of the following installation methods.

### Installation with pip

This yields an installation that uses the fparser frontend and is suitable for
development of transformations and working with the example notebooks:

```bash
python3 -m venv loki_env  # Create a virtual environment
source loki_env/bin/activate  # Activate the virtual environment

# Installation of the Loki core library
# Optional:
#   * Add `-e` to obtain an editable install that allows modifying the
#     source files without having to re-install the package
#   * Enable the following options by providing them as a comma-separated
#     list in square brackets behind the `.`:
#     * tests    - allows running the Loki test suite
#     * examples - installs dependencies to run the example notebooks
#     * docs     - installs dependencies required to generate the Sphinx documentation
#     * dace     - installs DaCe
pip install .

# Optional: Installation of IFS lint rules for the use as a linter
#           (again optionally with `-e` for an editable install)
pip install ./lint_rules
```

### Installation using install script

The provided `install` script can be used to install Loki with selected
dependencies inside a local virtual environment `loki_env`. This is the
recommended way when additional optional dependencies, such as CLAW, the OMNI
frontend, or Open Fortran Parser are required.

After downloading Loki, call the script with `-h` to display usage information:

```text
$ ./install -h
Loki install script. This installs Loki and selected dependencies.

Usage: ./install [-v] [--hpc2020] [--*-certificate[=]<path>] [--use-venv[=]<path>] [--with-*] [...]

Available options:
  -h / --help                  Display this help message
  -v                           Enable verbose output
  --hpc2020                    Load HPC2020 (Atos) specific modules and settings
  --proxy-certificate[=]<path> Provide https proxy certificate, disable cert verification for JDK/ant/OFP downloads
  --jdk-certificate[=]<path>   Provide trusted certificate for JDK runtime
  --use-venv[=]<path>          Use existing virtual environment at <path>
  --with[out]-jdk              Install JDK instead of using system version (default: use system version)
  --with[out]-ant              Install ant instead of using system version (default: use system version)
  --with[out]-claw             Install CLAW and OMNI Compiler (default: disabled)
  --with[out]-omni             Install OMNI Compiler; cannot be combined with --with-claw (default: disabled)
  --with[out]-ofp              Install Open Fortran Parser (default: disabled)
  --with[out]-dace             Install DaCe (default: enabled)
  --with[out]-tests            Install dependencies to run tests (default: enabled)
  --with[out]-docs             Install dependencies to generate documentation (default: disabled)
  --with[out]-examples         Install dependencies to run the example notebooks (default: enabled)
  --claw-install-env[=]<...>   Specify environmental variables for CLAW build and install
```

On the ECMWF Atos HPC facility, the `--hpc2020` flag is recommended as it loads
required modules.  Omitting all (other) options (i.e., any of the `--with-*`)
will install only the Fparser2 frontend.

After completion, this script writes a `loki-activate` file that can be sourced
to bring up the virtual environment and set paths for the external dependencies.

#### Examples:

The default command on ECMWF's Atos HPC facility for a full stack installation is

```bash
./install --hpc2020 --with-ant --with-omni --with-ofp
```

On standard Linux hosts with up-to-date JDK and ant, it is as easy as

```bash
./install --with-omni --with-ofp
```

To update the installation (e.g., to add JDK), the existing virtual environment can be provided, e.g.,

```bash
./install --with-omni --with-jdk --with-ant --use-venv=loki_env --with-ofp
```

### Installation using CMake/ecbuild

Loki and dependencies (excluding OpenFortranParser) can be installed using
[ecbuild](https://github.com/ecmwf/ecbuild) (a set of CMake macros and a wrapper
around CMake). This requires ecbuild 3.4+ and CMake 3.17+.

```bash
ecbuild <path-to-loki>
make
```

The following options are available and can be enabled/disabled by providing `-DENABLE_<feature>=<ON|OFF>`:

- `NO_INSTALL` (default: `OFF`): Do not install Loki but make the CMake
  functions below available. This is useful if Loki is available on the path from
  elsewhere and only the CMake integration is required
- `EDITABLE` (default: `OFF`): Install Loki in editable mode, i.e. without
  copying any files
- `OMNI` (default: `OFF`): Install the OMNI compiler as well as its
  Java dependencies as required. Note that this is an experimental setup and comes
  with no support or guarantees.
- `CLAW` (default: `OFF`): Install the CLAW with the included OMNI Compiler and their
  Java dependencies as required. Note that this is an experimental setup and comes
  with no support or guarantees.

This method is also suitable to create a system-wide installation of Loki:

```bash
mkdir build && cd build
ecbuild --prefix=<install-path> <path-to-loki>
make install
```

*Note: Using this to install Loki system-wide does currently not install OMNI Compiler and CLAW Compiler with it, even if the relevant ecbuild option is activated. It is recommended to install them separately, if required.*

The ecbuild installation method creates a virtual environment in the build
directory and downloads OpenJDK and Ant on-demand if no up-to-date versions have
been found.  This installation method is particularly handy when used as a
subproject of a larger CMake build.

When used this way, it exports a number of CMake functions that can then be used
elsewhere:

- `loki_transform_convert`: A wrapper for calls to `loki-transform.py` in
  `convert` mode that takes care of automatically setting path and environment.
- `loki_transform_transpile`: A wrapper for calls to `loki-transform.py` in
  `transpile` mode that takes care of automatically setting path and environment.
- `claw_compile`: A wrapper for calls to `clawfc` that takes care of
  automatically setting path and environment.
- `generate_xmod`: A wrapper for calls to OMNI's `F_Front` frontend to generate
  xmod dependency files.
- `loki_transform_plan`: A wrapper for calls to `loki-transform.py` in `plan`
  mode to generate CMake plan files.
- `loki_transform_ecphys`: A wrapper for calls to `loki-transform.py` in
  `ecphys` mode to apply bulk transformations across the ec_phys call tree
- `loki_transform_target`: A wrapper that takes care of calling the plan mode
  during configuration and applying bulk transformations at build time to a CMake
  target. This includes updates to the target's source file list as determined
  during the planning stage.

This allows to apply transformations as part of the build process without the
need to take care of PATH handling on the user side. See the [CLOUDSC
dwarf](https://github.com/ecmwf-ifs/dwarf-p-cloudsc) for an example how this can
be used.

## Installation on MacOS

Although tailored to the Linux environment commonly found on HPC systems, Loki
can also be installed on MacOS.

This requires installing some additional dependencies using
[Brew](https://brew.sh) to allow running the Loki test suite:


```bash
# Install dependencies with brew
brew install gcc@13 graphviz python@3.11

# Install Loki using the install script
# NB: we explicitly select Python 3.11 (in case a newer version is the default)
#     by adding it in first place to the search path
PATH="$(brew --prefix)/opt/python@3.11/libexec/bin:$PATH" \
  CC=gcc-13 CXX=g++-13 FC=gfortran-13 \
  ./install --with-examples --with-tests --with-dace

# Amend the Loki environment with correct compiler variables
echo "export PATH=$(brew --prefix)/opt/python@3.11/libexec/bin:$(brew --prefix)/bin:${PATH}" | cat - loki-activate > loki-activate.tmp
mv loki-activate.tmp loki-activate
echo "export CC=gcc-13" >> loki-activate
echo "export CXX=g++-13" >> loki-activate
echo "export FC=gfortran-13" >> loki-activate
echo "export F90=gfortran-13" >> loki-activate
echo "export LD=gfortran-13" >> loki-activate

# Activate the virtual environment to run the tests
source loki-activate
pytest --pyargs loki
```

## Installation as part of an ecbundle bundle

Loki being installable by CMake/ecbuild makes it easy to integrate with
[ecbundle](https://github.com/ecmwf/ecbundle). Simply add the following to your
`bundle.yml`:

```yaml
projects :

  # ...other projects ...

  - loki :
    git     : https://github.com/ecmwf-ifs/loki
    version : main

```

See the [CLOUDSC dwarf](https://github.com/ecmwf-ifs/dwarf-p-cloudsc) for an
example how this can be used.

## Manual installation

The following outlines the manual steps for installing Loki using a virtual
environment. This installation method is not recommended but may be used when
maximum control over all steps is required or all of the above are not working.
You can create an empty directory and copy-paste the following steps to obtain a
working version:

### 1. Clone the Loki repository

```bash
git clone https://github.com/ecmwf-ifs/loki
```

### 2. Create and activate virtual environment

```bash
python3 -m venv loki_env
source loki_env/bin/activate
pip install --upgrade pip
```

Note that we need to make sure that we use a recent pip version (21.3 or newer)
that has support for editable installs using `pyproject.toml`.

### 3.  Install Loki and Python dependencies

```bash
pushd loki
pip install -e .[tests,examples]
pip install -e ./lint_rules
popd
```

### 4.  Install OMNI compiler -- optional

#### Option a: install latest xcodeml-tools

```bash
git clone --recursive --single-branch https://github.com/omni-compiler/xcodeml-tools.git xcodeml-tools
pushd xcodeml-tools
# Now build and install OMNI in the venv:
cmake -S . -B build -DCMAKE_INSTALL_PREFIX=../loki_env
cmake --build build
cmake --install build
popd
```

#### Option b: install (older) OMNI version and CLAW

```bash
git clone --recursive --single-branch --branch=mlange-dev https://github.com/mlange05/claw-compiler.git claw-compiler
pushd claw-compiler
# Now build and install CLAW in the venv:
cmake -S . -B build -DCMAKE_INSTALL_PREFIX=../loki_env
cmake --build build
cmake --install build
popd
```

### 5.  Install OpenFortranParser (OFP) -- optional

```bash
pip install -e git+https://github.com/mlange05/open-fortran-parser-xml@mlange05-dev#egg=open-fortran-parser
# Fix version number in OFP to enable download of dependencies:
echo "VERSION = '0.5.3'" > loki_env/src/open-fortran-parser/open_fortran_parser/_version.py
python3 -m open_fortran_parser --deps
pushd loki_env/src/open-fortran-parser
mkdir -p lib
cp open_fortran_parser/*.jar lib
# Rebuild OFP binaries to include custom changes:
ant
popd
```

### 6.  Verify everything is working

```bash
pushd loki
py.test transformations lint_rules .
popd
```

Note that the order is important to avoid clashes with conftest utilities.

# Installation

There are multiple different ways of installing Loki, tailored towards various
use-cases:

- via `pip install` as a pure Python package
- via the provided install script to ease the setup of optional dependencies
- via CMake/ecbuild to enable installation as part of a CMake project
- via ecbundle
- manually

Loki is a pure Python package that depends on a range of upstream packages. We
recommend to use a
[virtual environment](https://packaging.python.org/en/latest/guides/installing-using-pip-and-virtual-environments/#creating-a-virtual-environment)
to avoid conflicts with versions of system-wide installed packages. The
CMake/ecbuild installation method as well as the provided script `install` will
do this automatically.

## Requirements

- Python 3.8+ with virtualenv and pip
- For OpenFortranParser/OMNI+CLAW:
  - JDK 1.8+ with ant (can be installed using the install script or ecbuild)
  - libxml2 (with headers)
- For graphical output from the scheduler: graphviz

## Installation via `pip install`

The easiest way to obtain a useable installation of Loki with the fparser frontend:

```bash
python3 -m venv loki_env  # Create a virtual environment
source loki_env/bin/activate  # Activate the virtual environment

# Installation of the Loki core library
pip install "loki @ git+https://github.com/ecmwf-ifs/loki.git"

# Optional: Installation of additional transformations
pip install "transformations @ git+https://github.com/ecmwf-ifs/loki.git#subdirectory=transformations"

# Optional: Installation of rules for the use as a linter
pip install "lint_rules @ git+https://github.com/ecmwf-ifs/loki.git#subdirectory=lint_rules"
```

This makes the Python package available and installs the scripts `loki-transform.py` and `loki-lint.py` on the PATH.


## Installation using install script

The provided `install` script can be used to install Loki with selected
dependencies inside a local virtual environment `loki_env`. This is the
recommended way when additional optional dependencies, such as CLAW, the OMNI
frontend, or Open Fortran Parser are required.

After downloading Loki, call the script with `-h` to display usage information:

```text
$ ./install -h
Loki install script. This installs Loki and selected dependencies.

Usage: ./install [-v] [--hpc2020] [--*-certificate[=]<path>] [--use-venv[=]<path>] [--with-*] [...]

Available options:
  -h / --help                  Display this help message
  -v                           Enable verbose output
  --hpc2020                    Load HPC2020 (Atos) specific modules and settings
  --proxy-certificate[=]<path> Provide https proxy certificate, disable cert verification for JDK/ant/OFP downloads
  --jdk-certificate[=]<path>   Provide trusted certificate for JDK runtime
  --use-venv[=]<path>          Use existing virtual environment at <path>
  --with[out]-jdk              Install JDK instead of using system version (default: use system version)
  --with[out]-ant              Install ant instead of using system version (default: use system version)
  --with[out]-claw             Install CLAW and OMNI Compiler (default: disabled)
  --with[out]-ofp              Install Open Fortran Parser (default: disabled)
  --with[out]-dace             Install DaCe (default: enabled)
  --with[out]-tests            Install dependencies to run tests (default: enabled)
  --with[out]-docs             Install dependencies to generate documentation (default: disabled)
  --with[out]-examples         Install dependencies to run the example notebooks (default: enabled)
  --claw-install-env[=]<...>   Specify environmental variables for CLAW build and install
```

On the ECMWF Atos HPC facility, the `--hpc2020` flag is recommended as it loads
required modules.  Omitting all (other) options (i.e., any of the `--with-*`)
will install only the Fparser2 frontend.

After completion, this script writes a `loki-activate` file that can be sourced
to bring up the virtual environment and set paths for the external dependencies.

### Examples:

The default command on ECMWF's Atos HPC facility for a full stack installation is

```bash
./install --hpc2020 --with-ant --with-claw --with-ofp
```

On standard Linux hosts with up-to-date JDK and ant, it is as easy as

```bash
./install --with-claw --with-ofp
```

To update the installation (e.g., to add JDK), the existing virtual environment can be provided, e.g.,

```bash
./install --with-claw --with-jdk --with-ant --use-venv=loki_env --with-ofp
```

## Installation using CMake/ecbuild

Loki and dependencies (excluding OpenFortranParser) can be installed using
[ecbuild](https://github.com/ecmwf/ecbuild) (a set of CMake macros and a wrapper
around CMake). This requires ecbuild 3.4+ and CMake 3.17+.

```bash
ecbuild <path-to-loki>
make
```

The following options are available and can be enabled/disabled by providing `-DENABLE_<feature>=<ON|OFF>`:

- `NO_INSTALL` (default: `OFF`): Do not install Loki but make the CMake
  functions below available. This is useful if Loki is available on the path from
  elsewhere and only the CMake integration is required
- `EDITABLE` (default: `OFF`): Install Loki in editable mode, i.e. without
  copying any files
- `CLAW` (default: `OFF`): Install the CLAW and OMNI Compiler as well as its
  Java dependencies as required. Note that this is an experimental setup and comes
  with no support or guarantees.

This method is also suitable to create a system-wide installation of Loki:

```bash
mkdir build && cd build
ecbuild --prefix=<install-path> <path-to-loki>
make install
```

*Note: Using this to install Loki system-wide does currently not install OMNI Compiler and CLAW Compiler with it, even if the relevant ecbuild option is activated. It is recommended to install them separately, if required.*

The ecbuild installation method creates a virtual environment in the build
directory and downloads OpenJDK and Ant on-demand if no up-to-date versions have
been found.  This installation method is particularly handy when used as a
subproject of a larger CMake build.

When used this way, it exports a number of CMake functions that can then be used
elsewhere:

- `loki_transform_convert`: A wrapper for calls to `loki-transform.py` in
  `convert` mode that takes care of automatically setting path and environment.
- `loki_transform_transpile`: A wrapper for calls to `loki-transform.py` in
  `transpile` mode that takes care of automatically setting path and environment.
- `claw_compile`: A wrapper for calls to `clawfc` that takes care of
  automatically setting path and environment.
- `generate_xmod`: A wrapper for calls to OMNI's `F_Front` frontend to generate
  xmod dependency files.
- `loki_transform_plan`: A wrapper for calls to `loki-transform.py` in `plan`
  mode to generate CMake plan files.
- `loki_transform_ecphys`: A wrapper for calls to `loki-transform.py` in
  `ecphys` mode to apply bulk transformations across the ec_phys call tree
- `loki_transform_target`: A wrapper that takes care of calling the plan mode
  during configuration and applying bulk transformations at build time to a CMake
  target. This includes updates to the target's source file list as determined
  during the planning stage.

This allows to apply transformations as part of the build process without the
need to take care of PATH handling on the user side. See the [CLOUDSC
dwarf](https://github.com/ecmwf-ifs/dwarf-p-cloudsc) for an example how this can
be used.

## Installation as part of an ecbundle bundle

Loki being installable by CMake/ecbuild makes it easy to integrate with
[ecbundle](https://github.com/ecmwf/ecbundle). Simply add the following to your
`bundle.yml`:

```yaml
projects :

  # ...other projects ...

  - loki :
    git     : https://github.com/ecmwf-ifs/loki
    version : main

```

See the [CLOUDSC dwarf](https://github.com/ecmwf-ifs/dwarf-p-cloudsc) for an
example how this can be used.

## Manual installation

The following outlines the manual steps for installing Loki using a virtual
environment. This installation method is not recommended but may be used when
maximum control over all steps is required or all of the above are not working.
You can create an empty directory and copy-paste the following steps to obtain a
working version:

### 1. Clone the Loki repository

```bash
git clone https://github.com/ecmwf-ifs/loki
```

### 2. Create and activate virtual environment

```bash
python3 -m venv loki_env
source loki_env/bin/activate
pip install --upgrade pip
```

Note that we need to make sure that we use a recent pip version (21.3 or newer)
that has support for editable installs using `pyproject.toml`.

### 3.  Install Loki and Python dependencies

```bash
pushd loki
pip install -e .[tests,examples]
pip install -e ./transformations
pip install -e ./lint_rules
popd
```

### 4.  Install CLAW with OMNI compiler -- optional

```bash
git clone --recursive --single-branch --branch=mlange-dev https://github.com/mlange05/claw-compiler.git claw-compiler
pushd claw-compiler
mkdir build
pushd build
# Now build and install CLAW in the venv:
cmake -DCMAKE_INSTALL_PREFIX=../../loki_env ..
make
make install
popd
popd
```

### 5.  Install OpenFortranParser (OFP) -- optional

```bash
pip install -e git+https://github.com/mlange05/open-fortran-parser-xml@mlange05-dev#egg=open-fortran-parser
# Fix version number in OFP to enable download of dependencies:
echo "VERSION = '0.5.3'" > loki_env/src/open-fortran-parser/open_fortran_parser/_version.py
python3 -m open_fortran_parser --deps
pushd loki_env/src/open-fortran-parser
mkdir -p lib
cp open_fortran_parser/*.jar lib
# Rebuild OFP binaries to include custom changes:
ant
popd
```

### 6.  Verify everything is working

```bash
pushd loki
py.test transformations lint_rules .
popd
```

Note that the order is important to avoid clashes with conftest utilities.

# Authors and Contributors

- R. Heilemann Myhre (Met Norway)
- S. Karppinen (FMI)
- P. Kiepas (École polytechnique/IPSL)
- M. Lange (ECMWF)
- J. Legaux (CERFACS)
- O. Marsden (ECMWF)
- A. Nawab (ECMWF)
- B. Reuter (ECMWF)
- J. Schmalfuß
- M. Staneker (ECMWF)

If you have contributed to this project, please add your name in the above
alphabetical list.

# Authors and Contributors

- A. Beggs (ECMWF)
- J. Ericsson (ECMWF)
- R. Heilemann Myhre (Met Norway)
- S. Karppinen (FMI)
- P. Kiepas (École polytechnique/IPSL)
- M. Lange (ECMWF)
- J. Legaux (CERFACS)
- O. Marsden (ECMWF)
- A. Nawab (ECMWF)
- B. Reuter (ECMWF)
- J. Schmalfuß
- M. Staneker (ECMWF)

If you have contributed to this project, please add your name in the above
alphabetical list.

# AGENTS

## Loki Test Conventions

This repository contains Loki source code and tests.

## Local Validation Workflow

When validating Loki changes locally:

- always activate the local environment first with `source ./loki-activate`
- use the repository-local pylint configuration with `pylint --rcfile .pylintrc ...`
- include both lint and test validation in normal verification
- prefer running targeted `pytest` suites for touched areas first, then broaden if needed

Typical validation commands:

```bash
source ./loki-activate
python -m pytest <relevant tests>
pylint --rcfile .pylintrc <relevant paths>
```

For broader validation, keep using the same activated environment and local `.pylintrc`.


## Commit Message Style

When creating commits in this repository:

- Use a sub-package or area marker in the subject, followed by a colon.
- Keep the subject concise and imperative, for example:
  `JIT: Add isolated JIT execution helper`
  `Transformations: Isolate parametrise JIT test execution`
- Wrap commit body lines like Python docstrings, preferably around 72 characters.
- Use the body to explain why the change is needed and what behavior it protects.


## Loki Test Assertions

When editing or adding tests, prefer assertions that match Loki's native IR and expression semantics rather than assertions that depend on rendered source formatting.

When editing test imports, keep `loki.*` import lines ordered alphabetically by submodule, but do not reorder names within a single import line unless there is a separate reason to do so.

- In structural IR tests, prefer native Loki node comparisons over `str(...)`.
- Loki symbols and expressions compare directly to strings, so prefer:
  - `node == 'a + b'` over `str(node) == 'a + b'`
  - `loop.variable == 'i'` over `str(loop.variable) == 'i'`
- Loki numeric literals compare directly to Python numbers, so prefer:
  - `loop.bounds.start == 1` over `str(loop.bounds.start) == '1'`
  - `literal == 5` over `str(literal) == '5'`
- When creating local test helpers, return native nodes whenever possible.
  - Good: `(assign.lhs, assign.rhs)`
  - Good: `(loop.variable, loop.bounds.start, loop.bounds.stop, loop.bounds.step)`
  - Avoid: `(str(assign.lhs), str(assign.rhs))`
  - Avoid: `(str(loop.variable), str(loop.bounds.start), str(loop.bounds.stop), ... )`
- Use stringification only when the test is explicitly about rendered output, pretty-printing, or a node type that does not compare reliably through Loki's native equality support.
- If stringification is still necessary in a structural test, keep it narrowly scoped and document why.
